#include "grader.h"
#include <string>
#include <algorithm>
#include <vector>
#define fs first
#define sc second
using namespace std;

const int MAXN = 200000;
int n;
long long ans = 0;
pair <int, int> a[MAXN];
int id[MAXN];
int wt[MAXN];
int m = 0;
vector <int> e[MAXN];
const int MODULE = 1000 * 1000 * 1000;


bool nw(int id)
{
	return ((id == 0) || (a[id].fs != a[id - 1].fs) || (a[id].sc != a[id - 1].sc + 1));
}

int dfs(int v, int p)
{
	int cs = wt[v];
	for (int i = 0; i < e[v].size(); i++)
	{
		if (e[v][i] == p) continue;
		cs += dfs(e[v][i], v);
	}
	ans += ((long long)cs * (n - cs));
	return cs;
}

void solve()
{
	sort(a, a + n);
	int p = 0;
	m = 0;
	for (int i = 0; i < n; i++)
	{
		bool ni = nw(i);
		pair <int, int> pp = make_pair(a[i].fs - 1, a[i].sc);
		while (a[p] < pp) p++;
		bool np = nw(p);
		if (ni) 
		{
			e[m].resize(0);	
			wt[m++] = 0;
		}
		id[i] = m - 1;
		wt[m - 1]++;
		if ((a[p] == pp) && (ni || np)) e[id[i]].push_back(id[p]), e[id[p]].push_back(id[i]);
	}
	dfs(0, 0);
}

int DistanceSum(int N, int *X, int *Y) {
	n = N;
	for (int i = 0; i < n; i++) a[i] = make_pair(X[i], Y[i]);
	solve();
	for (int i = 0; i < n; i++) a[i] = make_pair(Y[i], X[i]);
	solve();
	return ans % MODULE;
}