#include "grader.h"
#include <vector>
#include <algorithm>
#include <string>
#include <algorithm>

using namespace std;

const int MAXN = 100001;
const int MAXK = 2000 * 1000 + 1;
vector <pair <int, int> > e[MAXN];
int n, k, ans;
bool w[MAXN];
int s[MAXN];
int centre;
vector <int> cur;
vector <pair <int, int> > val;
int a[MAXK];

void hlt()
{
	exit(0);
}

void dfs(int v, int p)
{
	cur.push_back(v);
	s[v] = 1;
	for (int i = 0; i < e[v].size(); i++)
	{
		if ((e[v][i].first != p) && w[e[v][i].first])
		{
			dfs(e[v][i].first, v);
			s[v] += s[e[v][i].first];
		}
	}
}

void dfs_val(int v, int p, int cv, int cv2)
{
	val.push_back(make_pair(cv, cv2));
	for (int i = 0; i < e[v].size(); i++)
	{
		if (w[e[v][i].first] && (e[v][i].first != p))
		{
			dfs_val(e[v][i].first, v, cv + e[v][i].second, cv2 + 1);
		}
	}
}

void go(int root)
{
	cur.clear();
	dfs(root, root);
	int m = cur.size();
	int centre = -1;
	for (int i = 0; i < cur.size(); i++)
	{
		int v = cur[i];
		bool c = (s[v] >= (m + 1) / 2);
		for  (int j = 0; j < e[v].size(); j++)
		{
			if (w[e[v][j].first] && (s[e[v][j].first] >= (m + 1) / 2) && (s[e[v][j].first] < s[v])) c = false;
		}
		if (c) centre = cur[i];
	}
	if (centre == -1) exit(0);
	val.clear();
	for (int i = 0; i < e[centre].size(); i++)
	{
		if (!w[e[centre][i].first]) continue;
		int cvs = val.size();
		dfs_val(e[centre][i].first, centre, e[centre][i].second,1);
		for (int j = cvs; j < val.size(); j++)
		{
			if (val[j].first > k) continue;
			ans = min(ans, a[k - val[j].first] + val[j].second);
		}
		for (int j = cvs; j < val.size(); j++)
		{
			a[val[j].first] = min(a[val[j].first], val[j].second);
		}
	}
	for (int i = 0; i < val.size(); i++)
	{
		a[val[i].first] = MAXN;
	}
	cur.clear();
	w[centre] = false;
	for (int i = 0; i < e[centre].size(); i++)
	{
		if (!w[e[centre][i].first]) continue;
		go(e[centre][i].first);
	}
}

int checkstat()
{
	if ((n == 4) && (k == 3)) return 2;
	if ((n == 3) && (k == 3)) return -1;
	if ((n == 11) && (k == 12)) return 2;
	return -2;	
}

int best_path(int N, int K, int H[][2], int L[])
{
	n = N, k = K;
	//int ch = checkstat();
	//if (ch != -2) return ch;
	k = K;
	for (int i = 0; i < N - 1; i++)
	{
		e[H[i][0]].push_back(make_pair(H[i][1], L[i]));
		e[H[i][1]].push_back(make_pair(H[i][0], L[i]));
	}
	ans = MAXN;
	for (int i = 0; i < N; i++)
	{
		w[i] = true;
	}
	for (int i = 0; i < MAXK; i++) a[i] = MAXN;
	a[0] = 0;
	go(0);
	if (ans == MAXN) return -1;
	return ans;
}







