#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <numeric>
#define mp make_pair
#define pb push_back
#define y1 y1_dhs
#define NAME ""

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 8;
const int nmax = 8000 * 100;
const ll inf = 1000ll * 1000 * 1000 * 1000 * 1000;

struct aa
{
	ll maxh, add, ind, sum;
	aa(ll Maxh = 0, ll Add = 0, ll Ind = 0, ll Sum = 0)
	{
		maxh = Maxh;
		add = Add;
		ind = Ind;
		sum = Sum;
	}
};

ostream& operator << (ostream& out, aa a)
{
	return (out << "(maxh = " << a.maxh << "; add = " << a.add << "; ind = " << a.ind << ")");
}

aa a[nmax];

void upd(int ind, int l1, int r1, ll h)
{
	if (h <= 0)
	{
		a[ind].maxh = 0;
		a[ind].ind = l1;
		a[ind].add = h;
	}
	else
	{
		a[ind].maxh = h * (r1 - l1 + 1);
		a[ind].ind = r1;
		a[ind].add = h;
	}
	a[ind].sum = h * (r1 - l1 + 1);
}

void push(int ind, int l1, int r1)
{
	if (a[ind].add == 0)
		return;
	upd(ind * 2, l1, (l1 + r1) / 2, a[ind].add);
	upd(ind * 2 + 1, (l1 + r1) / 2 + 1, r1, a[ind].add);
	a[ind].add = 0;
}

void change(int ind, int l1, int r1, int l, int r, ll h)
{
	//cerr << "change " << ind << " " << l1 << " " << r1 << " " << l << " " << r << " " << h << endl;
	if (l1 > r || l > r1)
		return;
	if (l <= l1 && r1 <= r)
	{
		upd(ind, l1, r1, h);
		return;
	}
	push(ind, l1, r1);
	change(ind * 2, l1, (l1 + r1) / 2, l, r, h);
	change(ind * 2 + 1, (l1 + r1) / 2 + 1, r1, l, r, h);
	if (a[ind * 2].maxh >= a[ind * 2 + 1].maxh)
	{
		a[ind].maxh = a[ind * 2].maxh;
		a[ind].ind = a[ind * 2].ind;
	}
	else
	{
		a[ind].maxh = a[ind * 2 + 1].maxh;
		a[ind].ind = a[ind * 2 + 1].ind;
	}
	a[ind].sum = a[ind * 2].sum + a[ind * 2 + 1].sum;
}

int n, s, l, r, h;
char c;

ll getans(int ind, int l1, int r1, ll h)
{
//	cerr << "getans " << ind << " " << l1 << " " << r1 << " " << h << endl;
	if (a[ind].maxh <= h)
	{
		cerr << "Return " << n + s << endl;
		return n;
	}
	else
	{
		if (l1 == r1)
			return a[ind].ind;
		push(ind, l1, r1);
		if (a[ind * 2].maxh <= h)
			return getans(ind * 2 + 1, (l1 + r1) / 2 + 1, r1, h - a[ind * 2].sum);
		else
			return getans(ind * 2, l1, (l1 + r1) / 2, h);
	}	
}

int main()
{
	cin >> n >> c;
	s = 1;
	while (s < maxn)
		s *= 2;
	change(1, 0, s - 1, n, n, inf);
/*	for (int i = 1; i < s * 2; i++)
		cerr << i << " " << a[i] << endl;
	cerr << endl;*/
	while (c != 'E')
	{
		if (c == 'I')
		{
			cin >> l >> r >> h;
			l--;
			r--;
			change(1, 0, s - 1, l, r, h);
		}
		else
		{
			cin >> h;
			cout << getans(1, 0, s - 1, h) << endl;
		}
		cin >> c;
		/*for (int i = 1; i < s * 2; i++)
			cerr << i << " " << a[i] << endl;
		cerr << endl;*/
	}
}
