
#include <bits/stdc++.h>

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 879;
int n, s;
int sx, sy, fx, fy;
int b[N][N];
vector < int > qx, qy;

int main()
{
    ios::sync_with_stdio(false);

    cin >> n >> s;
    for (int i = 0; i < n; ++i)
    {
        string f;
        cin >> f;
        for (int j = 0; j < n; ++j)
            switch (f[j])
            {
            case 'T':
                b[i][j] = 0;
                break;
            case 'G':
                b[i][j] = IINF;
                break;
            case 'M':
                b[i][j] = IINF;
                sx = i; sy = j;
                break;
            case 'D':
                b[i][j] = IINF;
                fx = i; fy = j;
                break;
            case 'H':
                b[i][j] = 0;
                qx.push_back(i);
                qy.push_back(j);
                break;
            }
    }

    for (int i = 0; i < qx.size(); ++i)
    {
        int x = qx[i], y = qy[i];
        int nd = b[x][y] + 1;
        for (int j = 0; j < 4; ++j)
        {
            int nx = x + DX[j], ny = y + DY[j];
            if (nx < 0 || ny < 0 || nx >= n || ny >= n || (nx == fx && ny == fy) || b[nx][ny] <= nd)
                continue;
            b[nx][ny] = nd;
            qx.push_back(nx);
            qy.push_back(ny);
        }
    }

    cout << "\n";
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
            if (b[i][j] == IINF)
                cout << ".";
            else
                cout << b[i][j];
        cout << "\n";
    }

    int al = -1, ar = b[sx][sy] - 1;
    while (al < ar)
    {
        int ct = (al + ar + 1) / 2;
    
        static int d[N][N];
        memset(d, 0x3f, sizeof(d));
        qx.clear();
        qy.clear();
        
        d[sx][sy] = 0;
        qx.push_back(sx);
        qy.push_back(sy);
        for (int i = 0; i < qx.size(); ++i)
        {
            int x = qx[i], y = qy[i];
            if (d[x][y] / s >= b[x][y]-ct)
                continue;
            int nd = d[x][y] + 1;
            if (x == fx && y == fy)
                break;
            for (int j = 0; j < 4; ++j)
            {
                int nx = x + DX[j], ny = y + DY[j];
                if (nx < 0 || ny < 0 || nx >= n || ny >= n || d[nx][ny] <= nd)
                    continue;
                d[nx][ny] = nd;
                qx.push_back(nx);
                qy.push_back(ny);
            }
        }
        if (d[fx][fy] == IINF)
            ar = ct - 1;
        else
            al = ct;
    }

    cout << al << "\n";

    return 0;
}
