#include <stdlib.h>
#include "grader.h"
#include <algorithm>

using namespace std;

const int MAXN = 250001;
int a[MAXN];
int w[MAXN];

int valid(int n, int inputSeq[])
{
	int cr = -1;
	for (int i = 0; i < n; i++)
	{
		a[i] = inputSeq[i];
		if (inputSeq[i] <= n)
		{
			int c = (inputSeq[i] + n - i) % n;
			if (cr == c) continue;
			else if (cr == -1) cr = c;
			else cr = -2;
		}
	}
	sort(a, a + n);
	for (int i = 0; i < n - 1; i++)
	{
		if ((a[i] == a[i + 1])) return 0;
	}
	if (cr == -2) return 0;
	else return 1;	
}

int replacement(int n, int gondolaSeq[], int replacementSeq[])
{
	int cr = -1;
	for (int i = 0; i < n; i++)
	{
		if (gondolaSeq[i] <= n)
		{
			cr = (gondolaSeq[i] + n - i) % n;
		}
	}
	int mx = 0;
	for (int i = 1; i < MAXN; i++) w[i] = -1;
	if (cr == -1) cr = 0;
	for (int i = 0; i < n; i++)
	{
	   mx = max(gondolaSeq[i], mx);
	   w[gondolaSeq[i]] = i;
	   a[i] = (i + cr) % n;
	   if (a[i] == 0) a[i] = n;
	}
	for (int i = n + 1; i <= mx; i++)
	{
		if (w[i] == -1) replacementSeq[i - n - 1] = a[w[mx]], a[w[mx]] = i;
		else replacementSeq[i - n - 1] = a[w[i]], a[w[i]] = i;
	}
	return mx - n;
}

int countReplacement(int n, int inputSeq[])
{
  return -3;
}
