#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

int a[2000001];
int r[2000001];
int l[2000001];
int pos[4000001];

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<pair<int, int> > v;
    for (int i = 0; i < n; i++){
        while (!v.empty() && a[i] < v.back().first){
            r[v.back().second] = i - 1;
            v.pop_back();
        }
        v.push_back(make_pair(a[i], i));
    }
    while (!v.empty()){
        r[v.back().second] = n - 1;
        v.pop_back();
    }
    for (int i = 0; i < n; i++){
        while (!v.empty() && a[i] > v.back().first){
            v.pop_back();
        }
        if (!v.empty()){
            l[i] = v.back().second + 1;
        }
        else{
            l[i] = 0;
        }
        v.push_back(make_pair(a[i], i));
    }
    int minl = n;
    vector<pair<int, int> > ans;
    for (int i = n - 1; i >= 0; i--){
        int k = (a[i] - i) + 2000000;
        if (pos[k] > i && pos[k] <= r[i] && i >= l[pos[k]] && pos[k] <= minl){
            minl = i;
            ans.push_back(make_pair(i + 1, pos[k] + 1));
        }
        pos[k] = i;
    }
    cout << ans.size() << endl;
    for (auto p: ans){
        cout << p.first << " " << p.second << endl;
    }
    return 0;
}
