#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include "grader.h"
#define forn(i, n) for(int i = 0; i < n; i++)
#define mp(i, j) make_pair(i, j)
#define rs(a, j) a.resize(j)
#define pb(a, j) a.push_back(j)
#define pp(a) a.pop_back()
#define len(s) s.length()
#define sz(a) a.size()
#define re  return
#define fi first
#define se second
typedef long long ll;
typedef long double ld;
using namespace std;
const int ma = 1024, mi = 200000000;
int ans = 0, aa[2000][2000], use[2000][2000];
int DistanceSum(int N, int *X, int *Y) {
    vector<pair<ll, ll> > a, b;
    int mix, miy;
    forn (i, N) {
        a.push_back(mp(X[i], Y[i])),
        b.push_back(mp(Y[i], X[i]));
        if (i == 0) {
            mix = X[i];
            miy = Y[i];
        }
        mix = min(mix, X[i]);
        miy = min(miy, Y[i]);
    }
    forn (i, N) {
        aa[X[i] - mix][Y[i] - miy] = 1;
    }
    if (N <= 2000) {
        long long ans = 0;
        forn (i, N) {
            forn (j, N)
                use[X[j] - mix][Y[j] - miy] = 0;
            queue<pair<int, int> > ab;
            ab.push(mp(X[i] - mix, Y[i] - miy));
            use[X[i] - mix][Y[i] - miy] = 1;
            while (!ab.empty()) {
                if (ab.front().fi > 0 && use[ab.front().fi - 1][ab.front().se] == 0 &&
                    aa[ab.front().fi - 1][ab.front().se]) {
                    ab.push(mp(ab.front().fi - 1, ab.front().se));
                    use[ab.front().fi - 1][ab.front().se] = use[ab.front().fi][ab.front().se] + 1;
                    ans += use[ab.front().fi][ab.front().se];
                }
                if (ab.front().fi < 1999 && use[ab.front().fi + 1][ab.front().se] == 0 &&
                    aa[ab.front().fi + 1][ab.front().se]) {
                    ab.push(mp(ab.front().fi + 1, ab.front().se));
                    use[ab.front().fi + 1][ab.front().se] = use[ab.front().fi][ab.front().se] + 1;
                    ans += use[ab.front().fi][ab.front().se];
                }
                if (ab.front().se > 0 && use[ab.front().fi][ab.front().se - 1] == 0 &&
                    aa[ab.front().fi][ab.front().se - 1]) {
                    ab.push(mp(ab.front().fi, ab.front().se - 1));
                    use[ab.front().fi][ab.front().se - 1] = use[ab.front().fi][ab.front().se] + 1;
                    ans += use[ab.front().fi][ab.front().se];
                }
                if (ab.front().se < 1999 && use[ab.front().fi][ab.front().se + 1] == 0 &&
                    aa[ab.front().fi][ab.front().se + 1]) {
                    ab.push(mp(ab.front().fi, ab.front().se + 1));
                    use[ab.front().fi][ab.front().se + 1] = use[ab.front().fi][ab.front().se] + 1;
                    ans += use[ab.front().fi][ab.front().se];
                }
                ab.pop();
            }
        }
        re (ans / 2) % 1000000000;
    }
    int i = 0;
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    for (ll j = 1; j < N; j++) {
        ans = (ans + j * ll(N - j) * (a[j].fi - a[j - 1].fi)) % 1000000000;
        ans = (ans + j * (N - j) * (b[j].fi - b[j - 1].fi)) % 1000000000;
    }
    re ans;
}
/*
int x[100], y[100], n;
int main(){
    ifstream cin("input.txt");
    //iostream::sync_with_stdio(0);
    cin >> n;
    forn (i, n) cin >> x[i] >> y[i];
    cout << DistanceSum(n, x, y);
    return 0;
}*/
