#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <ctime>
#include <cassert>
#include <queue>
#include <stack>
#include <bitset>
#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define mt make_tuple
#define NAME ""

using namespace std;
	
typedef long long ll;
typedef long double ld;

const ld PI = acos(-1.0);

const ll INF = 1ll << 61;


int n;
struct node
{
	ll mx;
	ll sum;
	ll val;
	node *l, *r;
};



int lv, rv;
ll nv;
node* root;
node* newnode()
{
	node* ans = new node();
	ans->l = ans->r = NULL;
	ans->sum = ans->mx = 0;
	ans->val = 0;
	return ans;
}

int gt(ll h)
{
	node* t = root;
	int l = 0, r = n;
	while (l != r)
	{
		if (t->val != -INF)
		{
			return (h / (t->val) + l);
		}
		if (t->l->mx > h) t = t->l, r = (l + r) / 2;
		else 
		{
			h -= t->l->sum;
			t = t->r;
			l = (l + r) / 2 + 1;
		}
	}
	return l;
}

void setval(node* t, ll vl, int sz)
{
	t->sum = (ll)(sz) * vl;
	t->mx = max(0ll, t->sum);
	t->val = vl;
}

void modify(node* t, int l, int r)
{
	if ((lv > r) || (l > rv)) return;
	if ((lv <= l) && (r <= rv))
	{
		setval(t, nv, r - l + 1);
	}
	else
	{
		if (t->l == NULL) t->l = newnode();
		if (t->r == NULL) t->r = newnode();
		if (t->val != -INF)
		{
			setval(t->l, t->val, (r - l) / 2 + 1);
			setval(t->r, t->val, (r - l + 1) / 2);
			t->val = -INF;
		}
		modify(t->l, l, (l + r) / 2);
		modify(t->r, (l + r) / 2 + 1, r);
		t->mx = max(t->l->mx, t->l->sum + t->r->mx);
		t->sum = t->l->sum + t->r->sum;
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin >> n;
	root = new node();
	lv = rv = n;
	nv = INF;
	modify(root, 0, n);
	while (true)
	{
		char c;
		cin >> c;
		if (c == 'E')
			return 0;
		if (c == 'I')
		{
			cin >> lv >> rv >> nv;
			lv--, rv--;
			modify(root, 0, n);
		}
		else
		{
			ll h;
			cin >> h;
			cout << gt(h) << "\n";
		}
	}
	return 0;
}