#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <numeric>
#include <bitset>
#include <deque>
#include <fstream>
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define y1 y1_dhs
#define NAME ""

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T1, typename T2>
ostream& operator << (ostream &out, pair<T1, T2> a) {
	return (out << "(" << a.first << "; " << a.second << ")");
}

template<typename T1>
ostream& operator << (ostream &cout, vector<T1> &a) {
	if ((int)a.size() == 0)
		return (cout << "()");
	cout << "(" << a[0];
	for (int i = 1; i < (int)a.size(); i++)
		cout << "; " << a[i];
	cout << ")";
	return cout;
}

const int nmax = 1000 * 1000;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int maxc = 1001;

struct point {
    int x, y;
    point(){}
    point(int X, int Y) {
        x = X;
        y = Y;
    }
};

int n, x, y, dp[2][2][nmax];
vector<point> p;

int main() {
	//freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
    freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    scanf("%d", &n);
    p.pb(point(0, 0));
    for (int i = 0; i < n; i++) {
        scanf("%d%d", &x, &y);
        p.pb(point(x, y));
    }
    for (int i = 0; i < maxc * 2; i++) {
        dp[0][0][i] = dp[0][1][i] = dp[1][0][i] = dp[1][1][i] = inf;
    }
    dp[0][0][maxc] = 0;
    dp[0][1][maxc] = 0;
    int t = 0;
    for (int i = 1; i <= n; i++, t = 1 - t) {
        for (int j = 0; j < maxc * 2; j++) {
            dp[1 - t][0][j] = dp[1 - t][1][j] = inf;
        }
        for (int j = 0; j < maxc * 2; j++) {
            if (dp[t][0][j] != inf) {
                dp[1 - t][0][j] = min(dp[1 - t][0][j], dp[t][0][j] + abs(p[i].y - p[i - 1].y));
                dp[1 - t][1][p[i - 1].y + maxc] = min(dp[1 - t][1][p[i - 1].y + maxc], dp[t][0][j] + abs(j - maxc - p[i].x));
            }
            if (dp[t][1][j] != inf) {
                dp[1 - t][1][j] = min(dp[1 - t][1][j], dp[t][1][j] + abs(p[i].x - p[i - 1].x));
                dp[1 - t][0][p[i - 1].x + maxc] = min(dp[1 - t][0][p[i - 1].x + maxc], dp[t][1][j] + abs(j - maxc - p[i].y));
            }
        }
    }
    int answer = inf;
    for (int i = 0; i < maxc * 2; i++) {
        answer = min({answer, dp[t][0][i], dp[t][1][i]});
    }
    cout << answer << endl;
}

