#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <numeric>
#include <bitset>
#include <deque>
#include <fstream>
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define y1 y1_dhs
#define NAME ""

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T1, typename T2>
ostream& operator << (ostream &out, pair<T1, T2> a) {
	return (out << "(" << a.first << "; " << a.second << ")");
}

template<typename T1>
ostream& operator << (ostream &cout, vector<T1> &a) {
	if ((int)a.size() == 0)
		return (cout << "()");
	cout << "(" << a[0];
	for (int i = 1; i < (int)a.size(); i++)
		cout << "; " << a[i];
	cout << ")";
	return cout;
}

const int nmax = 150 * 1000 + 3;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;

int n, m, q, a[nmax], dp[nmax], x;
vector<int> ans;
bool used[nmax];

int main() {
	//freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
    //freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    cin >> q >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < nmax; i++) {
        dp[i] = 0;
    }
    dp[0] = -1;
    for (int i = 0; i < n; i++) {
        for (int j = nmax - 1; j >= 0; j--) {
            if (j + a[i] < nmax && dp[j] != 0 && dp[j + a[i]] == 0) {
                dp[j + a[i]] = i + 1;
            }
        }
    }
    int index = -1;
    for (int i = q; i >= 0; i--) {
        if (dp[i] != 0) {
            index = i;
            break;
        }
    }
    q -= index;
    int answer = index;
    while (dp[index] > -1) {
        used[dp[index] - 1] = true;
        index -= a[dp[index] - 1];
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            ans.pb(a[i]);
        }
    }
    for (int i = 0; i < m; i++) {
        cin >> x;
        ans.pb(x);
    }
    sort(ans.rbegin(), ans.rend());
    int top = 0;
    while (q > 0) {
        answer += min(a[top], q) - 1;
        q -= a[top++];
    }
    cout << answer << endl;
}

