#include "grader.h"
#include <algorithm>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1000 * 1000 + 2;
pair <int, int> ord[MAXN];
int tt[MAXN];
int val[5001][5001];

int gd(int x, int y)
{
	if (x > y) swap(x, y);
	if (x == y) return 0;
	if (val[x][y] == -1) val[x][y] = getDistance(x, y);
	return val[x][y];
}

void findLocation(int N, int first, int location[], int stype[])
{
	for (int i = 0; i < N; i++)
	{
		for (int j = i + 1; j < N; j++)
		{
			val[i][j] = -1;
		}
	}
	for (int i = 0; i < MAXN; i++) tt[i] = 0;
	for (int i = 0; i < N; i++)
	{
		ord[i] = make_pair(gd(0, i), i);
	}
	sort(ord, ord + N);
	int id1 = ord[1].second, d1 = ord[1].first, l1 = first + d1;
	int li = 0, ld = first, ri = id1, rd = l1;
	location[0] = first, stype[0] = 1, location[id1] = l1, stype[id1] = 2;
	for (int i = 0; i < N; i++)
	{
		int id = ord[i].second;
		if (i > 1)
		{
			int k0 = ord[i].first;
		    int k1 = gd(id1, id);
			if (d1 > k1)
			{
				location[i] = l1 - k1;
				stype[i] = 1;
			}
			else if  (k0 == k1 + d1)
			{
				int lk = gd(li, id);
				int v = ((l1 - ld) + lk - k1) / 2;
				if (tt[ld + v] == 1)
				{
					location[id] = ld + lk;
					stype[id] = 2;
				}
				else
				{
					location[id] = l1 - k1;
					stype[id] = 1;
					li = id;
					ld = l1 - k1;
				}
			}
			else
			{
				int rk = gd(ri, id);
				int v = ((rd - first) + rk - k0) / 2;
				if (tt[rd - v] == 2)
				{
				    location[id] = rd - rk;
					stype[id] = 1;
				}
				else
				{
					location[id] = first + k0;
					stype[id] = 2;
					ri = id;
					rd = first + k0;
				}
			}
		}
		tt[location[id]] = stype[id];
	}
}
