#include <iostream>
#include <cmath>

const int N = 55;
const int P = 8;

int n, p, cow[N][P];
bool imposs[N];
int impossCount;

int abs(int a)
{
	return (a >= 0) ? a : -a;
}

int getFit(int p, int x)
{
	int a = 0;
	for (int i = 0; i < n; ++i)
		if (!imposs[i] && cow[i][p] == x)
			++a;
	return abs(a * 2 - (n - impossCount));
}

int main()
{
	std::cin >> n >> p;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < p; ++j)
		{
			char c;
			std::cin >> c;
			cow[i][j] = c - 'X';
		}
	while (impossCount < n - 1)
	{
		int fit = 10000;
		int bprk = -1, bprx = -1;
		for (int i = 0; i < p; ++i)
		{
			int nf;
			nf = getFit(i, 0); if (nf < fit) { fit = nf; bprk = i; bprx = 0; }
			nf = getFit(i, 1); if (nf < fit) { fit = nf; bprk = i; bprx = 1; }
			nf = getFit(i, 2); if (nf < fit) { fit = nf; bprk = i; bprx = 2; }
		}
		std::cout << "Q " << bprk + 1 << " " << (char)('X' + bprx) << "\n";
		std::cout.flush();
		int ans;
		std::cin >> ans;
		if (ans)
		{
			for (int i = 0; i< n; ++i)
				if (!imposs[i] && cow[i][bprk] != bprx)
				{
					imposs[i] = true;
					++impossCount;
				}
		} else {
			for (int i = 0; i< n; ++i)
				if (!imposs[i] && cow[i][bprk] == bprx)
				{
					imposs[i] = true;
					++impossCount;
				}
		}
	}
	for (int i = 0; i < n; ++i)
		if (!imposs[i])
		{
			std::cout << "C " << i + 1 << "\n";
			return 0;
		}
	return 0;
}