#include "grader.h"
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 100002;
int f0[MAXN], f1[MAXN];
vector <int> e[MAXN];

int findSample(int N, int confidence[], int host[], int protocol[]) {
	//v00 - no old friends, no guy, no new friends v01 - no old friends, no guy, new friends
	//v10 - old friends, no guy, no new v11 = old, guy, no new, v12 = old, no guy, new
	int n = N;
	for (int i = 1; i < n; i++)
	{
		e[host[i]].push_back(i);
	}
	for (int i = n - 1; i >= 0; i--)
	{
		int v00 = 0, v01 = 0, v10 = 0, v11 = confidence[i], v12 = 0;
		for (int j = 0; j < e[i].size(); j++)
		{
			int n00, n01, n10, n11, n12, u = e[i][j];
			if (protocol[u] == 0)
			{
				n00 = v00 + f0[u];
				n01 = v01 + f1[u];
				n10 = v10 + f0[u];
				n11 = v11 + f0[u];
				n12 = v12 + f1[u];
			}
			if (protocol[u] == 1)
			{
				n00 = v00 + f0[u];
				n01 = v01 + f0[u];	
				n10 = v10 + f1[u];
				n11 = v11 + f1[u];
				n12 = max(v10 + f1[u], v12 + f0[u]);
			}
			if (protocol[u] == 2)
			{
				n00 = v00 + f0[u];
				n01 = v01 + f0[u];
				n10 = v10 + f0[u];
				n11 = v11 + f0[u];
				n12 = max(v10 + f1[u], v12 + f0[u]);
			}
			v00 = n00, v01 = n01, v10 = n10, v11 = n11, v12 = n12;
		}
		f0[i] = v01, f1[i] = max(v11, v12);
	}
	return f1[0];
}