#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include "grader.h"
#define forn(i, n) for(int i = 0; i < n; i++)
#define mp(i, j) make_pair(i, j)
#define rs(a, j) a.resize(j)
#define pb(a, j) a.push_back(j)
#define pp(a) a.pop_back()
#define len(s) s.length()
#define sz(a) (int)a.size()
#define re  return
#define fi first
#define se second
typedef long long ll;
typedef long double ld;
using namespace std;
const ll ma = 2097152;
int trmin[2 * ma], trmax[2 * ma];

void n_min(int l, int r, int l1, int r1, int nu, int trmi, int trma, int h) {
    //cout << l << " " << r << " " << l1 << " " << r1 << " " << nu << " " << trmi << " " << trma << " " << h << endl;
    if (nu > 1 && trmin[nu] < trmi)
        trmin[nu] = trmi;
    if (nu > 1 && trmax[nu] > trma)
        trmax[nu] = trma;
    if (l > r1 || r < l1)
        re;
    if (l <= l1 && r1 <= r) {
        trmin[nu] = max(trmin[nu], h);
        if (trmin[nu] > trmax[nu])
            trmax[nu] = trmin[nu];
        re;
    }
    n_min(l, r, l1, (l1 + r1) / 2, 2 * nu, trmin[nu], trmax[nu], h);
    n_min(l, r, (l1 + r1) / 2 + 1, r1, 2 * nu + 1, trmin[nu], trmax[nu], h);
    trmin[nu] = min(trmin[2 * nu], trmin[2 * nu + 1]);
    trmax[nu] = max(trmax[2 * nu], trmax[2 * nu + 1]);
    if (trmin[nu] > trmax[nu])
        trmax[nu] = trmin[nu];
}

void n_max(int l, int r, int l1, int r1, int nu, int trmi, int trma, int h) {
    //cout << l << " " << r << " " << l1 << " " << r1 << " " << nu << " " << trmi << " " << trma << " " << h << endl;
    if (nu > 1 && trmin[nu] < trmi)
        trmin[nu] = trmi;
    if (nu > 1 && trmax[nu] > trma)
        trmax[nu] = trma;
    if (l > r1 || r < l1)
        re;
    if (l <= l1 && r1 <= r) {
        trmax[nu] = min(trmax[nu], h);
        if (trmin[nu] > trmax[nu])
            trmin[nu] = trmax[nu];
        re;
    }
    n_max(l, r, l1, (l1 + r1) / 2, 2 * nu, trmin[nu], trmax[nu], h);
    n_max(l, r, (l1 + r1) / 2 + 1, r1, 2 * nu + 1, trmin[nu], trmax[nu], h);
    trmax[nu] = max(trmax[2 * nu], trmax[2 * nu + 1]);
    trmin[nu] = min(trmin[2 * nu], trmin[2 * nu + 1]);
    if (trmin[nu] > trmax[nu])
        trmin[nu] = trmax[nu];
}

void neww(int trmi, int trma, int nu) {
    if (nu > 1 && trmi > trmin[nu]) {
        trmin[nu] = trmi;
        if (trmin[nu] > trmax[nu] && trmin[nu] == trmi)
            trmax[nu] = trmin[nu];
    }
    if (nu > 1 && trmax[nu] > trma) {
        trmax[nu] = trma;
        if (trmin[nu] > trmax[nu] && trmax[nu] == trma)
            trmin[nu] = trmax[nu];
    }
    if (nu >= ma) {
        re;
    }
    neww(trmin[nu], trmax[nu], 2 * nu);
    neww(trmin[nu], trmax[nu], 2 * nu + 1);
}

//int n, k, op[100], left1[100], right1[100], height[100], finalHeight[100];
void buildWall(int n, int k, int op[], int left[], int right[], int height[], int finalHeight[]) {
    for (int i = n + ma; i < 2 * ma; i++)
        trmin[i] = 100001, trmax[i] = 100001;
    for (int i = ma; i < n + ma; i++)
        trmax[i] = 100001;
    for (int i = ma - 1; i > 0; i--)
        trmin[i] = min(trmin[2 * i], trmin[2 * i + 1]),
        trmax[i] = max(trmax[2 * i], trmax[2 * i + 1]);
    forn (i, k) {
        if (op[i] == 1)
            n_min(left[i] + ma, right[i] + ma, ma, 2 * ma - 1, 1, 0, 1000001, height[i]);
        else
            n_max(left[i] + ma, right[i] + ma, ma, 2 * ma - 1, 1, 0, 1000001, height[i]);
    }
    neww(0, 1000001, 1);
    for (int i = ma; i < ma + n; i++)
        finalHeight[i - ma] = trmin[i];
}
/*
int main(){
    ifstream cin("input.txt");
    iostream::sync_with_stdio(0);
    cin >> n >> k;
    forn (i, k) {
        cin >> op[i] >> left1[i] >> right1[i] >> height[i];
    }
    buildWall();
    forn (i, n)
        cout << finalHeight[i] << " ";
    return 0;
}*/
