#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
#include <cmath>
#include <map>
#include "grader.h"
#define forn(i, n) for(int i = 0; i < n; i++)
#define mp(i, j) make_pair(i, j)
#define rs(a, j) a.resize(j)
#define pb(a, j) a.push_back(j)
#define pp(a) a.pop_back()
#define len(s) s.length()
#define sz(a) a.size()
typedef long long ll;
typedef long double ld;
using namespace std;
/*void output(int i) {
    cout << i << " ";
}
int l, n, a[3000];
void send(int nu) {
    a[l] = nu;
    l++;
}*/
void encode(int N, int M[]) {
    int k = 0;
    forn (i, N) {
        int p = M[i];
        while (p > 0) {
            k += p % 2 * (i / 32 + 1);
            p /= 2;
        }
    }
    if (k < 6 * N) {
        send(0), send(0);
        send(0), send(0);
    }
    forn (i, N) {
        int p = M[i];
        forn (j, 8) {
            if ((k < 6 * N && p % 2 == 1) || (k >= 6 * N && p % 2 == 0)) {
                int pp = i % 32;
                send(pp * 8 + j);
                //cout << pp * 8 + j << " " << p << " " << i << endl;
                if (i / 32 == 1) send(pp * 8 + j);
            }
            p /= 2;
        }
    }
}

void decode(int N, int L, int X[]) {
    int a[N][8], p = -1, ans[N];
    forn (i, N)
        forn (j, 8) a[i][j] = 0;
    forn (i, L) {
        a[X[i] / 8][X[i] % 8]++;
    }
    forn (i, N) ans[i] = 255;
    if (a[0][0] >= 4) {
        a[0][0] -= 4;
        p = 1;
        forn (i, N) ans[i] = 0;
    }
    forn (i, N) {
        forn (j, 8) {
            if (a[i][j] >= 2) {
                a[i][j] -= 2; ans[i + 32] += p * (1 << j);
            }
            if (a[i][j] >= 1) ans[i] += p * (1 << j);
        }
    }
    forn (i, N) output(ans[i]);
}
/*
int main(){
    ifstream cin("input.txt");
  cin >>n;
  int b[n];
  forn (i, n)cin >> b[i];
  encode(n, b);
  random_shuffle(a, a + l);
  decode(n, l, a);
  return 0;
}*/
