#include <bits/stdc++.h>

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 1024;

int n, m, a, b, c, d;
int s[N][N], s2[N][N], s22[N][N];
int sc, sd, vc, vd;

void build()
{
    memcpy(s22, s2, sizeof(s2));
    vc = 1;
    while (vc*2 < sc)
    {
        for (int i = 0; i+vc < n; ++i)
            for (int j = 0; j < m; ++j)
                s22[i][j] = min(s22[i][j], s22[i+vc][j]);
        vc <<= 1;
    }
    vd = 1;
    while (vd*2 < sd)
    {
        for(int i = 0; i+vc < n; ++i)
            for (int j = 0; j+vd < m; ++j)
                s22[i][j] = min(s22[i][j], s22[i][j+vd]);
        vd <<= 1;
    }
}

int getMin(int x, int y)
{
    return min(min(s22[x][y], s22[x+sc-vc][y]), min(s22[x][y+sd-vd], s22[x+sc-vc][y+sd-vd]));
}

int main()
{
    ios::sync_with_stdio(false);

    cin >> m >> n >> b >> a >> d >> c;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            int x;
            cin >> x;
            s[i+1][j+1] = s[i+1][j] + s[i][j+1] - s[i][j] + x;
        }

    for (int i = 0; i <= n - c; ++i)
        for (int j = 0; j <= m - d; ++j)
            s2[i][j] = s[i+c][j+d] + s[i][j] - s[i][j+d] - s[i+c][j];

    sc = a-c-1;
    sd = b-d-1;
    build();

    int ax1, ay1, aa = 0, zz;
    for (int i = 0; i <= n-a; ++i)
        for (int j = 0; j <= m-b; ++j)
        {
            int ss = s[i+a][j+b] + s[i][j] - s[i][j+b] - s[i+a][j];
            int ssa = getMin(i+1, j+1);
            if (ss - ssa > aa)
            {
                aa = ss - ssa;
                zz = ssa;
                ax1 = i;
                ay1 = j;
            }
        }

    for (int i = ax1+1; i <= ax1+a-1-c; ++i)
        for (int j = ay1+1; j <= ay1+b-1-d; ++j)
            if (s2[i][j] == zz)
            {
                cout << ay1+1 << " " << ax1+1 << "\n";
                cout << j+1 << " " << i+1 << "\n";
                return 0;
            }
    return 0;
}
