#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <numeric>
#include <bitset>
#include <deque>
#include <fstream>
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define y1 y1_dhs
#define NAME ""

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T1, typename T2>
ostream& operator << (ostream &out, pair<T1, T2> a) {
	return (out << "(" << a.first << "; " << a.second << ")");
}

template<typename T1>
ostream& operator << (ostream &cout, vector<T1> &a) {
	if ((int)a.size() == 0)
		return (cout << "()");
	cout << "(" << a[0];
	for (int i = 1; i < (int)a.size(); i++)
		cout << "; " << a[i];
	cout << ")";
	return cout;
}

const int nmax = 1000;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int dx[] = {0, 1, 0, -1};
const int dy[] = {1, 0, -1, 0};

int sp, n;
string s[nmax];
queue<pair<int, int> > qu;
int dist[nmax][nmax], tim[nmax][nmax], mx, my, hx, hy;

int get(int tt) {
    return tt / sp + (tt % sp != 0);
}

bool check(int t) {
    cerr << "CHECK " << t << endl;
    qu.push(mp(mx, my));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            tim[i][j] = inf;
        }
    }
    tim[mx][my] = 0;
    while (qu.size()) {
        int x = qu.front().first, y = qu.front().second;
        qu.pop();
        for (int j = 0; j < 4; j++) {
            int nx = x + dx[j], ny = y + dy[j];
            if (nx >= 0 && nx < n && ny >= 0 && ny < n && (s[nx][ny] == 'G' || s[nx][ny] == 'D') && t + (tim[x][y] + 1) / sp < dist[nx][ny] && tim[nx][ny] == inf) {
                tim[nx][ny] = tim[x][y] + 1;
                qu.push(mp(nx, ny));
            }
        }
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cerr << tim[i][j] << " ";
        }
        cerr << endl;
    }*/
    return tim[hx][hy] != inf;
}

int main() {
	//freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
    //freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    scanf("%d%d", &n, &sp);
    getline(cin, s[0]);
    for (int i = 0; i < n; i++) {
        getline(cin, s[i]);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (s[i][j] == 'T') {
                dist[i][j] = 0;
            } else if (s[i][j] == 'G') {
                dist[i][j] = -1;
            } else if (s[i][j] == 'M') {
                dist[i][j] = -1;
                mx = i, my = j;
            } else if (s[i][j] == 'H') {
                dist[i][j] = 0;
                qu.push(mp(i, j));
            } else {
                dist[i][j] = inf;
                hx = i;
                hy = j;
            }
        }
    }
    while (qu.size()) {
        int x = qu.front().first;
        int y = qu.front().second;
        qu.pop();
        for (int i = 0; i < 4; i++) {
            int nx = x + dx[i], ny = y + dy[i];
            if (nx >= 0 && nx < n && ny >= 0 && ny < n && dist[nx][ny] == -1) {
                dist[nx][ny] = dist[x][y] + 1;
                qu.push(mp(nx, ny));
            }
        }
    }
    int l = -1, r = dist[mx][my];
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(m)) {
            l = m;
        } else {
            r = m;
        }
    }
    cout << l << endl;
}

