#include "grader.h"
#include <algorithm>

typedef long long ll;
const int N = 100179;

ll sum[N];

ll getSumLR(int l, int r)
{
    return sum[r + 1] - sum[l];
}

int besthub(int n, int l, int x[], long long b)
{
    std::sort(x, x + n);
    int answer = 0;
    sum[0] = 0;
    for (int i = 0; i < n; ++i)
        sum[i + 1] = sum[i] + x[i];
    for (int i = 0; i < n; ++i)
    {
        int bl = i, br = n - 1;
        while (bl != br)
        {
            int r = (bl + br + 1) / 2;
            int p = (i + r) / 2;
            ll ss = getSumLR(p, r) - x[p] * (r - p + 1);
            ss += x[p] * (p - i + 1) - getSumLR(i, p);
            if (ss > b)
                br = r - 1;
            else
                bl = r;
        }
        answer = std::max(answer, br - i + 1);
    }
    return answer;
}
