#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <list>
using namespace std;

#define name ""
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(ll i = 0; i < (ll)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC
#define inb push_back

struct __isoff{
	__isoff(){
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, freopen("test.txt", "w", stderr);
		//  else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		srand(time(0));
	}
	~__isoff(){
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 31;
const ull p2 = 29;
const double eps = 1e-8;
const double pi = acos(-1.0);

const ll inf = 1e18 + 7;
const int infi = 1e9 + 7;
const ll dd = 1e6 + 70;
const ll mod = 1e9 + 7;

struct tr{
	int lt, rt, f, mi, l;
	tr(){
		l = lt = rt = f = 0;
		mi = 0;
	}
	tr(int t){
		mi = t;
		l = 0;
	}
};

tr F[dd * 4];
int Pu[dd * 4];
void build(int v, int l, int r){
	if (l == r){
		F[v].l = 1;
		F[v].f = F[v].lt = F[v].rt = F[v].l;
		return;
	}
	build(v * 2, l, (l + r) / 2);
	build(v * 2 + 1, (l + r) / 2 + 1, r);
	F[v].l = F[v * 2].l + F[v * 2 + 1].l;
	F[v].f = F[v].lt = F[v].rt = F[v].l;
}


void push(int v){
	F[v * 2].mi += Pu[v];
	F[v * 2 + 1].mi += Pu[v];
	Pu[v * 2] += Pu[v];
	Pu[v * 2 + 1] += Pu[v];
	Pu[v] = 0;
}

tr mer(tr a, tr b){
	tr t;
	if (a.mi == b.mi){
		t.mi = a.mi;
		if (a.l == a.f){
			t.lt = a.l + b.lt;
		}
		else{
			t.lt = a.lt;
		}
		if (b.l == b.f){
			t.rt = b.l + a.rt;
		}
		else{
			t.rt = b.rt;
		}
		t.f = max(a.rt + b.lt, max(a.f, b.f));
	}
	else{
		if (a.mi < b.mi){
			t.mi = a.mi;
			t.lt = a.lt;
			t.f = a.f;
		}
		else{
			t.mi = b.mi;
			t.rt = b.rt;
			t.f = b.f;
		}
	}
	t.l = a.l + b.l;
	return t;
}

void up(int v, int lq, int rq, int l, int r, int t){
	if (lq > rq)
		return;
	if (lq == l && rq == r){
		Pu[v] += t;
		F[v].mi += t;
		return;
	}
	push(v);
	int s = (l + r) / 2;
	up(v * 2, lq, min(rq, s), l, s, t);
	up(v * 2 + 1, max(lq, s + 1), rq, s + 1, r, t);
	F[v] = mer(F[v * 2], F[v * 2 + 1]);
}

tr get(int v, int lq, int rq, int l, int r){
	if (lq > rq)
		return tr(infi);
	if (lq == l && rq == r){
		return F[v];
	}
	push(v);
	int s = (l + r) / 2;
	auto t = mer(get(v * 2, lq, min(rq, s), l, s),
		get(v * 2 + 1, max(lq, s + 1), rq, s + 1, r));

	F[v] = mer(F[v * 2], F[v * 2 + 1]);
	return t;
	
}


int getf(){
	auto t = F[1];
	if (t.mi > 0)
		return 0;
	return t.f;
}

/*
struct seg{
	vector<int> F[dd * 4];

	void build(vector<int> &t, int v, int l, int r){
		if (l == r){
			F[v] = vector<int>(1, t[l]);
			return;
		}
		int s = (l + r) / 2;
		build(t, v * 2, l, s);
		build(t, v * 2 + 1, s + 1, r);
		F[v].resize(F[v * 2].size() + F[v * 2 + 1].size());
		merge(F[v * 2].begin(), F[v * 2].end(), F[v * 2 + 1].begin(), F[v * 2 + 1].end(), F[v].begin());
	}

	int get(int v, int l, int r, int a, int b, int lq, int rq){
		if (l > r)
			return 0;
		if (l == lq && r == rq){
			return lower_bound(F[v].begin(), F[v].end(), b) - upper_bound(F[v].begin(), F[v].end(), a);
		}
		int s = (lq + rq) / 2;
		return get(v * 2, l, min(r, s), a, b, lq, s) + get(v * 2 + 1, max(l, s + 1), r, a, b, s + 1, rq);
	}

};
*/

int n, m, p;
ll b;
vector<int> X1, Y1, X2, Y2, C;

struct segS{
	int F[dd * 4], P[dd * 4];
	segS(){
		forn(i, dd * 4)
			F[i] = P[i] = 0;
	}
	void push(int v){
		F[v * 2] += P[v];
		F[v * 2 + 1] += P[v];
		P[v * 2] += P[v];
		P[v * 2 + 1] += P[v];
		P[v] = 0;
	}
	void up(int l, int r, int x, int v = 1, int lq = 0, int rq = dd - 1){
		if (l > r)
			return;
		if (l == lq && r == rq){
			F[v] += x;
			P[v] += x;
			return;
		}
		push(v);
		int s = (lq + rq) / 2;
		up(l, min(r, s), x, v * 2, lq, s);
		up(max(l, s + 1), r, x, v * 2 + 1, s + 1, rq);
		F[v] = min(F[v * 2], F[v * 2 + 1]);
	}
	int get(int l, int r, int v = 1, int lq = 0, int rq = dd - 1){
		if (l > r)
			return infi;
		if (l == lq && r == rq)
			return F[v];
		push(v);
		F[v] = min(F[v * 2], F[v * 2 + 1]);
		int s = (lq + rq) / 2;
		return min(get(l, min(s, r), v * 2, lq, s), get(max(s + 1, l), r, v * 2 + 1, s + 1, rq));
	}
};
segS W;
vector<pair<pair<int, int>, int> > T[dd];

bool is(int s){
	forn(i, dd)
		T[i].clear();
	forn(i, dd * 4)
		W.F[i] = W.P[i] = 0;
	forn(i, p){
		T[X1[i]].push_back(mk(mk(max(Y1[i] - s + 1, 0), Y2[i]), C[i]));
		T[min(X2[i] + s, m)].push_back(mk(mk(max(Y1[i] - s + 1, 0), Y2[i]), -C[i]));
	}
	int ef = -1;
	forn(i, m){
		forn(j, T[i].size()){
			W.up(T[i][j].first.first, min(T[i][j].first.second, (int)dd - 1), T[i][j].second);
		}
		if (T[i].size() || i == m - 1 || i == s - 1){
			ef = W.get(0, n - s);
			if (i >= s - 1 && ef <= b)
				return 1;
		}
	}
	return 0;
}

vector<pair<int, int> > Xqq[dd], Xww[dd];

int main(){
	cin >> m >> n >> b >> p;
	forn(i, p){
		int x1, y1, x2, y2, c;
		scanf("%d%d%d%d%d", &x1, &y1, &x2, &y2, &c);
		x1--, y1--, x2--, y2--;
		X1.push_back(x1);
		X2.push_back(x2);
		Y1.push_back(y1);
		Y2.push_back(y2);
		C.push_back(c);
		Xqq[x1].push_back(mk(y1, y2));
		Xww[x2 + 1].push_back(mk(y1, y2));
	}
	if (b > 0){
		if (p == 0){
			cout << min(n, m);
			return 0;
		}
		int l = 0, r = min(n, m) + 1;
		while (r - l > 1){
			int s = (l + r) / 2;
			if (is(s))
				l = s;
			else
				r = s;
		}
		cout << l;
	}
	else{
		int res = 0;
		int t = -1;
		swap(n, m);
		Xqq[n].push_back(mk(0, m - 1));
		build(1, 0, m - 1);
		forn(i, n){
			forn(j, Xww[i].size())
				up(1, Xww[i][j].first, Xww[i][j].second, 0, m - 1, -1);
			while (1){
				t++;
				int w = getf();
				if (w < t - i){
					t--;
					break;
				}
				forn(j, Xqq[t].size())
					up(1, Xqq[t][j].first, Xqq[t][j].second, 0, m - 1, 1);
			}
			res = max(res * 1ll, t - i);
		}
		cout << res;
	}
}