#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <numeric>
#include <bitset>
#include <deque>
#include <fstream>
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define y1 y1_dhs
#define NAME ""

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T1, typename T2>
ostream& operator << (ostream &out, pair<T1, T2> a) {
	return (out << "(" << a.first << "; " << a.second << ")");
}

template<typename T1>
ostream& operator << (ostream &cout, vector<T1> &a) {
	if ((int)a.size() == 0)
		return (cout << "()");
	cout << "(" << a[0];
	for (int i = 1; i < (int)a.size(); i++)
		cout << "; " << a[i];
	cout << ")";
	return cout;
}

const int nmax = 1000;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;

int n, m, d[nmax][nmax];
pair<int, int> ans[nmax][nmax];

int main() {
	//freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
    //freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            d[i][j] = 0;
            for (int i1 = 1; i1 <= i / 2 && !d[i][j]; i1++) {
                if (d[i - i1][j] == 0) {
                    d[i][j] = 1;
                    ans[i][j] = mp(i - i1, j);
                }
            }
            for (int j1 = 1; j1 <= j / 2 && !d[i][j]; j1++) {
                if (!d[i][j - j1]) {
                    d[i][j] = 1;
                    ans[i][j] = mp(i, j - j1);
                }
            }
        }
    }
    assert(d[n][m]);
    while (n != -1 || m != -1) {
        if (ans[n][m].first != n) {
           cout << "H " << ans[n][m].first << endl;
        } else {
            cout << "V " << ans[n][m].second << endl;
        }
        cin >> n >> m;
    }
}

