#include <iostream>
#include <stdio.h>
#include "grader.h"
#define mp make_pair

using namespace std;

const int nmax = 1000 * 1000;
const int inf = 1000 * 1000 * 1000;

template<typename T1, typename T2>
ostream& operator << (ostream &out, pair<T1, T2> a)
{
	return (out << "(" << a.first << "; " << a.second << ")");
}

int s = 1;
pair<int, int> a[nmax];

void push(int ind)
{
	if (a[ind].first != -1)
	{
		a[ind * 2] = mp(max(a[ind * 2].first, a[ind].first), max(a[ind * 2].second, a[ind].first));
		a[ind * 2 + 1] = mp(max(a[ind * 2 + 1].first, a[ind].first), max(a[ind * 2 + 1].second, a[ind].first));
	}
	if (a[ind].second != inf)
	{
		a[ind * 2] = mp(min(a[ind * 2].first, a[ind].second), min(a[ind * 2].second, a[ind].second));
		a[ind * 2 + 1] = mp(min(a[ind * 2 + 1].first, a[ind].second), min(a[ind * 2 + 1].second, a[ind].second));
	}
	a[ind] = mp(-1, inf);
}

void makemin(int ind, int l1, int r1, int l, int r, int h)
{
	if (l1 > r || l > r1)
		return;
	if (l <= l1 && r1 <= r)
	{
		a[ind] = mp(max(a[ind].first, h), max(a[ind].second, h));
		return;
	}
	push(ind);
	makemin(ind * 2, l1, (l1 + r1) / 2, l, r, h);
	makemin(ind * 2 + 1, (l1 + r1) / 2 + 1, r1, l, r, h);
}

void makemax(int ind, int l1, int r1, int l, int r, int h)
{
	if (l1 > r || l > r1)
		return;
	if (l <= l1 && r1 <= r)
	{
		a[ind] = mp(min(a[ind].first, h), min(a[ind].second, h));
		return;
	}
	push(ind);
	makemax(ind * 2, l1, (l1 + r1) / 2, l, r, h);
	makemax(ind * 2 + 1, (l1 + r1) / 2 + 1, r1, l, r, h);
}

void buildWall(int n, int k, int op[], int left[], int right[], int height[], int finalHeight[])
{
	s = 1;
	while (s < n)
		s *= 2;
	for (int i = 0; i <= s * 2; i++)
		a[i] = mp(-1, inf);
	for (int i = 0; i < k; i++)
	{
		cerr << "operation " << i << endl;
		if (op[i] == 1)
		{
			makemin(1, 0, s - 1, left[i], right[i], height[i]);
		}
		else
		{
			makemax(1, 0, s - 1, left[i], right[i], height[i]);
		}
//		for (int i = 1; i < s * 2; i++)
//			cerr << i << " " << a[i] << endl;
//		cerr << endl;
//		cerr << "operation done\n";
	}
	for (int i = 1; i < s; i++)
		push(i);	
	for (int i = 0; i < n; i++)
		finalHeight[i] = max(0, a[i + s].first);
}

