#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <stdlib.h>
#include <string>
#include <cstring>
#include <cassert>
#include <ctime>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#define NAME ""
#define mp make_pair
#define pb push_back
#define y1 gfjlkdf

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000 * 1000 * 1000;
const int nmax = 1000;
const int maxlog = 23;
const int force = 27;
const int dx[] = {0, 1, 0, -1};
const int dy[] = {1, 0, -1, 0};

int n, d;
string s[nmax];
int dist[nmax][nmax], disth[nmax][nmax], distm[nmax][nmax];
bool used[nmax][nmax];
pair<int, int> posm, posd;
queue<pair<int, int> > qu;

bool good(int x)
{
	return (x >= 0 && x < n);
}

struct cmp
{
	bool operator()(pair<int, int> a, pair<int, int> b)
	{
		return (dist[a.first][a.second] > dist[b.first][b.second]);
	}
};

set<pair<int, pair<int, int> > > a;

int main()
{
	freopen(NAME".in", "r", stdin);
	freopen(NAME".out", "w", stdout);
	cin >> n >> d;
	getline(cin, s[0]);
	for (int i = 0; i < n; i++)
		getline(cin, s[i]);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			disth[i][j] = inf, used[i][j] = false;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			if (s[i][j] == 'M')
				posm = mp(i, j);
			else if (s[i][j] == 'D')
				posd = mp(i, j);
			else if (s[i][j] == 'H')
			{
				qu.push(mp(i, j));
				disth[i][j] = 0;
				used[i][j] = true;
			}
//	cerr << "Read\n";
	while (!qu.empty())                                                                    
	{
		pair<int, int> v = qu.front();
		qu.pop();
		for (int j = 0; j < 4; j++)
		{
			pair<int, int> np = mp(v.first + dx[j], v.second + dy[j]);
			if (!good(np.first) || !good(np.second) || (s[np.first][np.second] != 'G' && s[np.first][np.second] != 'M') || used[np.first][np.second])
				continue;
			disth[np.first][np.second] = min(disth[np.first][np.second], disth[v.first][v.second] + 1);
			used[np.first][np.second] = true;
			qu.push(np);
		}
	}
//	cerr << "BFS 1\n";
	qu.push(posm);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
	 		used[i][j] = false, distm[i][j] = inf;
	used[posm.first][posm.second] = true;
	/*distm[posm.first][posm.second] = 0;
	while (!qu.empty())
	{
	 	pair<int, int> v = qu.front();
	 	qu.pop();
		for (int j = 0; j < 4; j++)
		{
			pair<int, int> np = mp(v.first + dx[j], v.second + dy[j]);
			if (!good(np.first) || !good(np.second) || (s[np.first][np.second] != 'G' && s[np.first][np.second] != 'D') || used[np.first][np.second])
				continue;
			distm[np.first][np.second] = min(distm[np.first][np.second], distm[v.first][v.second] + 1);
			used[np.first][np.second] = true;
			qu.push(np);
		}
	}*/
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			distm[i][j] = inf;
	distm[posm.first][posm.second] = 0;
//	for (int i = 0; i < n; i++)
//		for (int j = 0; j < n; j++)
//			cout << distm[i][j] << (j == n - 1 ? "\n" : " ");
//	cout << endl;
//	for (int i = 0; i < n; i++)
//		for (int j = 0; j < n; j++)
//			cout << disth[i][j] << (j == n - 1 ? "\n" : " ");
//	cout << endl;
//	cerr << "BFS 2\n";
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			used[i][j] = false, dist[i][j] = 0;
	dist[posm.first][posm.second] = disth[posm.first][posm.second] - distm[posm.first][posm.second] / d - (distm[posm.first][posm.second] % d != 0 ? 1 : 0);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
		{
			if (s[i][j] == 'T')
				continue;
			a.insert(mp(-dist[i][j], mp(i, j)));
		}                                                                                                                             
	while (a.size())
	{
		pair<int, pair<int, int> > v1 = *(a.begin());
		pair<int, int> v = v1.second; 
		a.erase(a.begin());
		for (int j = 0; j < 4; j++)
		{
			pair<int, int> np = mp(v.first + dx[j], v.second + dy[j]);
			if (!good(np.first) || !good(np.second) || (s[np.first][np.second] != 'G' && s[np.first][np.second] != 'D') || used[np.first][np.second])
				continue;
			a.erase(a.find(mp(-dist[np.first][np.second], np)));
			distm[np.first][np.second] = dist[v.first][v.second] + 1;
			dist[np.first][np.second] = max(dist[np.first][np.second], min(dist[v.first][v.second], disth[np.first][np.second] - distm[np.first][np.second] / d - (distm[np.first][np.second] % d != 0 ? 1 : 0)));
			a.insert(mp(-dist[np.first][np.second], np));
		}
		used[v.first][v.second] = true;
	}
//	cout << endl;
//	for (int i = 0; i < n; i++)
//		for (int j = 0; j < n; j++)
//			cout << dist[i][j] << (j == n - 1 ? "\n" : " ");
//	cout << endl;
	if (dist[posd.first][posd.second] == 0)
		cout << -1 << endl;
	else
		cout << dist[posd.first][posd.second] << endl;
	return 0;
}