#include "grader.h"  
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 2000001;
int s[MAXN];
int c[MAXN];
vector <int> e[MAXN];

void dfs(int v, int p)
{
	s[v] = c[v];
	for (int i = 0; i < e[v].size(); i++)
	{
		if (e[v][i] != p)
		{
			dfs(e[v][i], v);
			s[v] += s[e[v][i]];
		}
	}
}


int LocateCentre(int N, int pp[], int S[], int D[]) {
	for (int i = 0; i < N; i++) c[i] = pp[i];
	for (int i = 0; i < N - 1; i++)
	{
		e[S[i]].push_back(D[i]);
		e[D[i]].push_back(S[i]);
	}
	dfs(0, 0);
	int res = 2000 * 1000 * 1001;
	int br = -1;
	for (int cur = 0; cur < N; cur++)
	{
		int cr  = 0;
		for (int i = 0; i < e[cur].size(); i++)
		{
			int s2 = s[e[cur][i]];
			if (s[e[cur][i]] > s[cur]) s2 = s[0] - s[cur];
			cr = max(cr, s2);
		}
		if (res > cr) res = cr, br = cur;
	}
	return br;
}
