#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

const int N = 5000555;
const long long INF = 0x3f3f3f3f3f3f3f3f;

int n, m[N];
long long v[N];

long long vA(int x)
{
	if (x % 2 == 0)
		return 1;
	return -1;
}
long long vB(int x)
{
	return v[x];
}

long long mx = INF, mn = -INF;

bool check(long long x)
{
	for (int i = 0; i < n; ++i)
	{
		if (x > m[i])
			return false;
		x = m[i]*2 - x;
	}
	return true;
}

int main()
{	
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &m[i]);
		v[i+1] = 2*m[i] - v[i];
	}
	for (int i = 0; i <= n; ++i)
	{
		// vA(i)*x + vB(i) <= m[i]
		if (vA(i) == 1)
		{
			// x <= m[i] - vB(i)
			if (i != n)
				mx = std::min(mx, m[i] - vB(i));
		} else {
			// x >= vB(i) - m[i]
			if (i != n)
				mn = std::max(mn, vB(i) - m[i]);
		}
	}
	std::cout << std::max(mx - mn + 1, 0ll);
	return 0;
}
