#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

const int N = 3000333;
const int G = 3333;
const int S = 26*2;
const int INF = 0x3f3f3f3f;

char s[N], g[G];
int good[S], gc, r, curr[S], n, k;

void set(int n, int v)
{
	if (curr[n] == good[n])
		--gc;
	curr[n] = v;
	if (curr[n] == good[n])
		++gc;	
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	scanf("%d%d", &k, &n);
	scanf("%s", g);
	scanf("%s", s);
	for (int i = 0; s[i] != '\0'; ++i)
	{
		if (s[i] >= 'a' && s[i] <= 'z')
			s[i] -= 'a';
		else
			s[i] = s[i] - 'A' + 26;
	}
	for (int i = 0; g[i] != '\0'; ++i)
	{
		if (g[i] >= 'a' && g[i] <= 'z')
			g[i] -= 'a';
		else
			g[i] = g[i] - 'A' + 26;
		++good[g[i]];
	}
	if (n < k)
	{
		std::cout << 0;
		return 0;
	}
	for (int i = 0; i < S; ++i)
		if (good[i] == 0)
			++gc;
	for (int i = 0; i < k; ++i)
		set(s[i], curr[s[i]] + 1);
	for (int i = 0; i+k <= n; ++i)
	{
		if (gc == S)
			++r;
		set(s[i], curr[s[i]] - 1);
		if (i + k != n)
			set(s[i+k], curr[s[i+k]] + 1);
	}
	std::cout << r;
	return 0;
}
