#include "grader.h"
#include <bits/stdc++.h>

typedef long long ll;
typedef std::pair < int , int > pair;

const int N = 100179;
const int MOD = 1000000000;

int n;
int *x, *y;
ll ans;

struct Vertex
{
    ll c;
    std::vector < int > e;
} v[N];
int vc;
std::set < pair > ew;
std::map < pair , int > kw;

int dfs(int cv, int p = -1)
{
    int ret = v[cv].c;
    for (int nv : v[cv].e)
    {
        if (nv == p)
            continue;
        int cnt = dfs(nv, cv);
        ret += cnt;
        (ans += 1ll * cnt * (n - cnt)) %= MOD;
    }
    return ret;
}

void solve()
{
    vc = 0;
    ew.clear();
    kw.clear();
    std::vector < pair > sq;
    for (int i = 0; i < n; ++i)
        sq.push_back({x[i], y[i]});
    std::sort(sq.begin(), sq.end());
    for (int i = 0; i < sq.size(); ++i)
    {
        if (i == 0 || sq[i - 1] != std::make_pair(sq[i].first, sq[i].second - 1))
        {
            v[vc].e.clear();
            v[vc].c = 1;
            kw[sq[i]] = vc++;
        } else
            ++v[kw[sq[i]] = vc - 1].c;
        auto it = kw.find({sq[i].first - 1, sq[i].second});
        if (it != kw.end())
        {
            int i2 = it->second;
            if (ew.find({vc - 1, i2}) == ew.end())
            {
                ew.insert({vc - 1, i2});
                v[vc - 1].e.push_back(i2);
                v[i2].e.push_back(vc - 1);
            }
        }
    }
    dfs(0);
}

int DistanceSum(int nn, int *X, int *Y)
{
    n = nn;
    ans = 0;
    x = X;
    y = Y;
    solve();
    std::swap(x, y);
    solve();
    return ans;
}
