#include "grader.h"
#include <vector>
#include <limits.h>
#include <iostream>

using namespace std;

vector< vector<int> > tr;
vector<int> megasum, wgt;
vector<bool> used;
int ans, num;


int sum(int v)
{
	used[v] = true;
	megasum[v] = wgt[v];
	for (int i = 0; i < tr[v].size(); i++)
	{
		if (!used[tr[v][i]])
			megasum[v] += sum(tr[v][i]);
	}
	//~ cout << megasum[v] << endl;
	return megasum[v];
}

void dfs(int v, int prs)
{
	used[v] = true;
	int mns = prs;
	int supersum = prs + wgt[v], i;
	for (i = 0; i < tr[v].size(); i++)
	{
		if (!used[tr[v][i]])
		{
			mns = max(mns, megasum[tr[v][i]]);
			supersum += megasum[tr[v][i]];
		}
	}
	if (mns < ans)
	{
		ans = mns;
		num = v;
	}
	//~ cout << ans << ' ' << num << ' ' << supersum << endl;
	for (i = 0; i < tr[v].size(); i++)
	{
		if (!used[tr[v][i]])
		{
			dfs(tr[v][i], supersum - megasum[tr[v][i]]);
		}
	}
}

int LocateCentre(int N, int pp[], int S[], int D[]) {
	tr.resize(N);
	megasum.resize(N);
	wgt.resize(N);
	used.resize(N);
	int i;
	for (i = 0; i < N; i++)
		wgt[i] = pp[i];
	for (i = 0; i < N - 1;i++)
	{
		tr[S[i]].push_back(D[i]);
		tr[D[i]].push_back(S[i]);
	}
	used.assign(N, false);
	ans = INT_MAX;
	sum(0);
	used.assign(N, false);
	dfs(0, 0);
	return num;
}
