#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1000001;

int n, p[MAXN];
bool w[MAXN];
int c[MAXN];

 int Solve()
{
	for (int i = 0; i < n; i++) w[i] = false;
	for (int i = 0; i < n; i++)
	{
		int ad = i - p[i];
		if (ad < 0) ad += n;
		w[ad] = true;
	}
	int prv = n - 1;
	while (!w[prv]) prv--;
	for (int i = 0; i < n; i++)
	{
		if (w[i]) prv = i;
		int ad = i - prv;
		if (ad < 0) ad += n;
		c[i] = ad;
	}
	prv = 0;
	while (!w[prv]) prv++;
	for (int i = n - 1; i >= 0; i--)
	{
		if (w[i]) prv = i;
		int ad = prv - i;
		if (ad < 0) ad += n;
		c[i] = min(c[i], ad);
	}
	int res = n / 2;
	for (int i = 0; i < n; i++)
	{
		int id1 = (i + n / 2);
		int id2 = (i + (n + 1)/2);
		if (id1 >= n) id1 -= n;
		if (id2 >= n) id2 -= n;
		res = min(res, n / 2 - min(c[id1], c[id2]));;
	}
	return res;
}

int main()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", p[i]);
		p[i]--;
	}
	int res = Solve();
	for (int i = 1; i < n - i; i++)
	{
		swap(p[i], p[n - i]);
	}
	res = min(res, Solve());
	cout << res << endl;
	return 0;
}