#include "grader.h"
#include <algorithm>
#include <vector>
#include <string>

using namespace std;
const int MAXN = 1000001;

vector <int> e[MAXN];
vector <int> cc;
int con[MAXN];
void dfs(int v, int p, int& v0,  int& v1)
{
	int s0 = 0, s1 = 0;
	for (int i = 0; i < e[v].size(); i++)
	{
		int n0 = 0, n1 = 0;
		if (e[v][i] != p) dfs(e[v][i], v, n0, n1);
		s0 += n0, s1 += n1;
	}
	v0 = s1;
	v1 = max(s1, s0 + con[v]);
}

int findSample(int N, int confidence[], int host[], int protocol[]) {
	for (int i = 0; i < N; i++) con[i] = confidence[i];
	if (N <= 10)
	{
		for (int i = 1; i < N; i++)
		{
			if (protocol[i] != 0)
			{
				for (int j = 0; j < e[host[i]].size(); j++) e[i].push_back(e[host[i]][j]), e[e[host[i]][j]].push_back(i);
			}
			if (protocol[i] != 1) e[i].push_back(host[i]), e[host[i]].push_back(i);
		}
		int ans = 0;
		for (int i = 0; i < (1 << N); i++)
		{
			int ca = 0;
			cc.clear();
			int ti = i;
			for (int j = 0; j < N; j++)
			{
				if (ti % 2) cc.push_back(j), ca += confidence[j];	
				ti /= 2;
			}
			bool ok = true;
			for (int j = 0; j < cc.size(); j++)
			{
				for (int j2 = 0; j2 < cc.size(); j2++)
				{
					for (int j3 = 0; j3 < e[cc[j]].size(); j3++)
					{
						if (e[cc[j]][j3] == cc[j2]) ok = false;
					}
				}
			}
			if (ok) ans = max(ans, ca);	
		}
		return ans;
	}
	else if (protocol[1] == 1)
	{
		int ans = 0;
		for (int i =0; i < N; i++) ans += confidence[i];
		return ans;
	}
	else if (protocol[1] == 2)
	{
		int ans = 0;
		for (int i =0; i < N; i++) ans = max(ans, confidence[i]);
		return ans;
	}
	else
	{
		for (int i = 1; i < N; i++)
		{
			if (protocol[i] != 0)
			{
				for (int j = 0; j < e[host[i]].size(); j++) e[i].push_back(e[host[i]][j]), e[e[host[i]][j]].push_back(i);
			}
			if (protocol[i] != 1) e[i].push_back(host[i]), e[host[i]].push_back(i);
		}
		int a0, a1;
		dfs(0, 0, a0, a1);
		return a1;
	}
}
