#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <math.h>

using namespace std;

const int MAXN = 100001;
const int INF = 1000 * 1000 * 1000;
int fx[MAXN], fy[MAXN];
int x[MAXN], y[MAXN];
int main()
{
	int n;
	cin >> n;
	fx[0] = fy[0] = 0;
	x[0] = y[0] = 0;
	for (int i = 1; i <= n; i++)
	{
		cin >> x[i] >> y[i];
		int mnx = INF, mny = INF;
		for (int j = 0; j < i; j++)
		{
			int ny = fx[j] + abs(y[i] - y[j]);
			int nx = fy[j] + abs(x[i] - x[j]);
			mny = min(mny, ny);
			mnx = min(mnx, nx);
		}
		for (int j = 0; j < i - 1; j++)
		{
			fx[j] += abs(x[i] - x[i - 1]);
			fy[j] += abs(y[i] - y[i - 1]);
		}
		fx[i - 1] = mnx, fy[i - 1] = mny;
		fx[i] = fy[i] = INF;
	}
	int rs = INF;
	for (int i = 0; i < n; i++)
	{
		rs = min(rs, fx[i]);
		rs = min(rs, fy[i]);
	}
	cout << rs << endl;
	return 0;
}