#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <queue>
using namespace std;

const int MAXN = 2000001;
int lg[MAXN], rg[MAXN];
vector <int> e[4 * MAXN];	
int a[MAXN];
int st[MAXN], stc = 0;
priority_queue <pair <int, int> > q;
vector <pair <int, int> > c;
vector <pair <int, int> > d;
int main()
{
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &a[i]);
		e[n + i - a[i]].push_back(i);
	}
	stc = 0;
	for (int i = 0; i < n; i++)
	{
		while ((stc > 0) && (a[st[stc - 1	]] > a[i]))
		{
			rg[st[--stc]] = i;
		}
		st[stc++] = i;
	}
	while (stc != 0)
	{
		rg[st[--stc]] = n;
	}
	for (int i = n - 1; i >= 0; i--)
	{
		while ((stc > 0) && (a[st[stc - 1]] < a[i]))
		{
			lg[st[--stc]] = i;
		}
		st[stc++] = i;
	}
	while (stc != 0)
	{
		lg[st[--stc]] = -1;
	}
	for (int i = 0; i < 2 * n; i++)
	{
		while (!q.empty()) q.pop();
		if (e[i].size() == 0) continue;
		int m = e[i].size();
		int mrg = n;
		for (int j = m - 1; j >= 0; j--)
		{
			int v = e[i][j];
			while ((!q.empty()) && (q.top().second >= v)) q.pop();
			if (!q.empty())
			{
				int tp = -q.top().first;
				if ((tp < rg[v]) && (tp < mrg))
				{
					c.push_back(make_pair(v, tp));
					mrg = tp;
				}
			}
			q.push(make_pair(-v, lg[v]));
		}
	}
	for (int i = 0; i < c.size(); i++)
	{
		swap(c[i].first, c[i].second);
	}
	sort(c.begin(), c.end());
	int lv = -1;
	for (int i = 0; i < c.size(); i++)
	{
		if (c[i].second > lv)
		{
			d.push_back(make_pair(c[i].second, c[i].first));
			lv = c[i].second;
		}
	}
	cout << d.size() << endl;
	for (int i = 0; i < d.size(); i++)
	{
		printf("%d %d\n", d[i].first + 1, d[i].second + 1);
	}
	return 0;
}	