#include "grader.h"
#include <bits/stdc++.h>

const int N = 5179;

int p2d[N], pp[N];

void exploreCave(int n) {
    memset(p2d, -1, sizeof(p2d));
    memset(pp, -1, sizeof(pp));

    for (int i = 0; i < n; ++i)
    {
        std::vector < int > op;
        for (int j = 0; j < n; ++j)
            if (p2d[j] == -1)
                op.push_back(j);
        int cp[N];
        for (int j = 0; j < n; ++j)
            cp[j] = (pp[j] == -1 ? 0 : pp[j]);
        int res = tryCombination(cp);
        int cpp = (res == i ? 1 : 0);
        int l = 0, r = op.size() - 1;
        while (l != r)
        {
            int m = (l + r + 1) / 2;
            for (int j = 0; j < m; ++j)
                cp[op[j]] = 1 - cpp;
            for (int j = m; j < op.size(); ++j)
                cp[op[j]] = cpp;
            res = tryCombination(cp);
            if (res == i)
                r = m - 1;
            else
                l = m;
        }
        p2d[op[l]] = i;
        pp[op[l]] = cpp;
    }

    answer(pp, p2d);
}
