#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <queue>
#include <stack>
#include <stdlib.h>
#include <cassert>
#include <bitset>
#include <ctime>
#include "grader.h"
#define mp make_pair
#define pb push_back
#define y1 y1_jkd

using namespace std;

typedef long long ll;
typedef long double ld;

const int nmax = 1000 * 1000;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 9;

vector<int> a;

int valid(int n, int* in)
{
	a.resize(n);
	for (int i = 0; i < n; i++)
	{
		a[i] = in[i];
		if (a[i] < 1)
			return false;
	}
	sort(a.begin(), a.end());
	for (int i = 1; i < n; i++)
		if (a[i] == a[i - 1])
			return false;
	int ind = min_element(in, in + n) - in;
	if (in[ind] > n)
		return true;
	else
	{
		int qq = (in[ind] % n) + 1;
		for (int index = (ind + 1) % n; index != ind; index = (index + 1) % n, qq = (qq % n) + 1)
			if (in[index] <= n && in[index] != qq)
			{
//				cerr << "in[index] != qq " << in[index] << " " << index << " " << qq << endl;
				return false;
			}
	}
	return true;
}

vector<pair<int, int> > b;
vector<int> ans;

int replacement(int n, int* in, int* repl)
{
//	cerr << 1 << endl;
	b.clear();
	b.resize(n);
	int top = 0, last = n + 1;
	int ind = min_element(in, in + n) - in;
	ans.resize(n);
	if (in[ind] <= n)
	{
		ans[ind] = in[ind];
		int qq = (in[ind] % n) + 1;
		for (int index = (ind + 1) % n; index != ind; index = (index + 1) % n, qq = (qq % n) + 1)
			ans[index] = qq;
	}
	else
	{
		for (int i = 0; i < n; i++)
			ans[i] = i + 1;
	}
//	cerr << 1 << endl;
	for (int i = 0; i < n; i++)
		b.pb(mp(in[i], i));
	sort(b.begin(), b.end());
	for (int i = 0; i < (int)b.size(); i++)
	{
		if (b[i].first <= n)
			continue;
		while (ans[b[i].second] != b[i].first)
		{
			repl[top++] = ans[b[i].second];
			ans[b[i].second] = last++;
		}
	}
	return top;
}

int pow(int k, int ind)
{
	if(ind == 0)
		return 1;
	ll kk = pow(k, ind / 2);
	if (ind % 2 == 0)
		return (kk * kk) % mod;
	else
		return (((kk * kk) % mod) * k) % mod;
}

int countReplacement(int n, int* in)
{
	if (!valid(n, in))
		return 0;
	ll answ = 1;
	b.clear();
	b.resize(n);
	int last = n + 1;
	int ind = min_element(in, in + n) - in;
	ans.resize(n);
	if (in[ind] <= n)
	{
		ans[ind] = in[ind];
		int qq = (in[ind] % n) + 1;
		for (int index = (ind + 1) % n; index != ind; index = (index + 1) % n, qq = (qq % n) + 1)
			ans[index] = qq;
	}
	else
	{
		answ = n;
		for (int i = 0; i < n; i++)
			ans[i] = i + 1;
	}
	for (int i = 0; i < n; i++)
		b.pb(mp(in[i], i));
	sort(b.begin(), b.end());
	for (int i = 0; i < (int)b.size(); i++)
	{
		if (b[i].first <= n)
			continue;
		answ = (answ * pow((int)b.size() - i, b[i].first - last)) % mod;
		last = b[i].first + 1;
	}
	return answ;
}
