#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef double dl;
struct treap{
    dl x, sum, cnt;
    int y;
    treap *l, *r;
    treap(){};
};
typedef treap * ptr;
ptr root = nullptr;
ptr create(dl x){
    ptr t = new treap();
    t->l = nullptr;
    t->r = nullptr;
    t->x = x;
    t->cnt = 1;
    t->sum = x;
    t->y = rand();
    return t;
}
dl cnt(ptr t){
    return t == nullptr ? 0 : t->cnt;
}
dl sum(ptr t){
    return t == nullptr ? 0 : t->sum;
}
void upd_cnt(ptr &t){
    t->cnt = cnt(t->l) + cnt(t->r) + 1;
    t->sum = sum(t->l) + sum(t->r) + t->x;
}
void split(ptr t, int key, ptr &L, ptr &R){
    if (t == nullptr){
        L = nullptr;
        R = nullptr;
        return;
    }
    if (t->x > key)
        split(t->l, key, L, t->l), R = t;
    else
        split(t->r, key, t->r, R), L = t;
    upd_cnt(t);
}
void merge(ptr &t, ptr l, ptr r){
    if (l == nullptr){
        t = r;
        return;
    }
    if (r == nullptr){
        t = l;
        return;
    }
    if (l->y > r->y)
        merge(l->r, l->r, r), t = l;
    else
        merge(r->l, l, r->l), t = r;
    upd_cnt(t);
}
void insert(ptr &t, dl key){
    ptr it = create(key);
    ptr t1, t2;
    split(t, key, t1, t2);
    merge(t1, t1, it);
    merge(t, t1, t2);
}
dl suf_sum(ptr t, int x){
    if (t == nullptr)
        return 0;
    int now = cnt(t->l) + 1;
    if (x < now)
        return suf_sum(t->l, x);
    if (x == now)
        return sum(t->l) + t->x;
    return sum(t->l) + t->x + suf_sum(t->r, x - cnt(t->l) - 1);
}
int n, l[500000], ansh, ansk;
pair<pair<dl, dl>, int> q[500000];
dl w, anss;
int v[500000];
pair<dl, int> s[500000];
int main()
{
    //ifstream cin("a.in");
    //ofstream cout("a.out");
    //ios::sync_with_stdio(false);
    scanf("%d%f", &n, &w);
    for (int i = 0; i < n; i++)
        l[i] = -1;
    for (int i = 0; i < n; i++){
        int a, b;
        scanf("%d%d", &a, &b);
        q[i] = make_pair(make_pair((dl)a / (dl)b, b), i + 1);
    }
    sort(q, q + n);
    int last = -1;
    for (int i = 0; i < n; i++){
        insert(root, q[i].first.second);
        int tl = -1, tr = i + 1;
        while (tr - tl > 1){
            int tm = (tl + tr) / 2;
            if (suf_sum(root, tm + 1) * q[i].first.first <= w)
                tl = tm;
            else
                tr = tm;
        }
        dl sum;
        if (tl == -1)
            sum = 0;
        else
            sum = suf_sum(root, tl + 1);
        int k = tl + 1;
        if (k > ansh || (k == ansh && sum < anss)){
            ansk = i;
            ansh = k;
            anss = sum;
        }
    }
    printf("%d\n", ansh);
    dl sum = 0;
    for (int j = 0; j <= ansk; j++)
        v[j] = 0;
    for (int i = 0; i <= ansk; i++)
        s[i] = make_pair(q[i].first.second, i);
    sort(s, s + (ansk + 1));
    for (int i = 0; i < ansh; i++){
        v[s[i].second] = 1;
    }
    for (int i = 0; i <= ansk; i++)
        if (v[i])
            printf("%d\n", q[i].second);
}
