#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 100001;
int fx[MAXN], fy[MAXN];
int x[MAXN], y[MAXN];
int nx[MAXN], ny[MAXN];
const int INF = 1000 * 1000 * 1000;

int main()
{
	int n;
	cin >> n;
	x[0] = 0, y[0] = 0;
	fx[0] = fy[0] = 0;
	for (int i = 1; i <= n; i++)
	{
		cin >> x[i] >> y[i];
		nx[i] = ny[i] = INF;
		for (int j = 0; j + 1 < i; j++)
		{ 
			nx[j] = fx[j] + abs(x[i] - x[i - 1]);
			ny[j] = fy[j] + abs(y[i] - y[i - 1]);
		}
		nx[i - 1] = ny[i - 1] = INF;
		for (int j = 0; j < i; j++)
		{
			nx[i - 1] = min(nx[i - 1], fy[j] + abs(x[i] - x[j]));
			ny[i - 1] = min(ny[i - 1], fx[j] + abs(y[i] - y[j]));
		}
		for (int j = 0; j <= i; j++) fx[j] = nx[j], fy[j] = ny[j];
	}
	int rs = INF;
	for (int i = 0; i <= n; i++) rs = min(rs, fx[i]), rs = min(rs, fy[i]);
	cout << rs << endl;
	return 0;
}