#include <bits/stdc++.h>

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 279;

int n, m;
int rc, k;
int a[N][N], s[N][N];
int a1[N][N], s1[N][N];
int r[N][N], r1[N][N];
int r1m[N][N];

inline int getSum(int x1, int y1, int x2, int y2)
{
    ++x2;
    ++y2;
    return s[x2][y2] - s[x1][y2] - s[x2][y1] + s[x1][y1];
}

inline int getSum1(int x1, int y1, int x2, int y2)
{
    ++x2;
    ++y2;
    return s1[x2][y2] - s1[x1][y2] - s1[x2][y1] + s1[x1][y1];
}

int main()
{
    ios::sync_with_stdio(false);

    cin >> n >> m >> rc >> k;
    for (int i = 0; i < rc; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        ++a[x][y];
        ++a1[n-1-x][m-1-y];
    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            s[i+1][j+1] = s[i][j+1] + s[i+1][j] - s[i][j] + a[i][j];
            s1[i+1][j+1] = s1[i][j+1] + s1[i+1][j] - s1[i][j] + a1[i][j];
        }

    for (int x = 0; x < n; ++x)
        for (int y = 0; y < m; ++y)
        {
            if (getSum(0, 0, x, y) < k)
            {
                r[x][y] = IINF;
                continue;
            }
            int crc = 0;
            int cx = 0, cy = y+1;
            while (crc < k && cy > 0)
            {
                --cy;
                crc += getSum(0, cy, x, cy);
            }
            int cans = IINF;
            while (cx <= x && cy >= 0)
            {
                int rn = getSum(cx, cy, x, y);
                if (rn == k)
                    cans  = min(cans, (x-cx)+(y-cy));
                if (rn >= k)
                    ++cx;
                else
                    --cy;
            }
            r[x][y] = (cans+2)*2;
        }


    for (int x = 0; x < n; ++x)
        for (int y = 0; y < m; ++y)
        {
            if (getSum1(0, 0, x, y) < k)
            {
                r1[x][y] = IINF;
                continue;
            }
            int crc = 0;
            int cx = 0, cy = y+1;
            while (crc < k && cy > 0)
            {
                --cy;
                crc += getSum1(0, cy, x, cy);
            }
            int cans = IINF;
            while (cx <= x && cy >= 0)
            {
                int rn = getSum1(cx, cy, x, y);
                if (rn == k)
                    cans  = min(cans, (x-cx)+(y-cy));
                if (rn >= k)
                    ++cx;
                else
                    --cy;
            }
            r1[x][y] = (cans+2)*2;
        }

    for (int i = 0; i <= n; ++i)
        r1m[i][0] = IINF;
    for (int i = 0; i <= m; ++i)
        r1m[0][i] = IINF;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            r1m[i+1][j+1] = min(min(r1m[i+1][j], r1m[i][j+1]), r1[i][j]);

    int ans = IINF;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            ans = min((ll)ans, (ll)r[i][j] + min(r1m[n][m-j-1], r1m[n-i-1][m]));
    cout << (ans == IINF ? -1 : ans) << "\n";

    return 0;
}
