#include "grader.h"
#include <iostream>
#include <cstring>
#include <set>
#include <vector>

const int N = 100500;
typedef long long lint;
typedef std::pair < lint , int > pair;
const lint INF = 0x3f3f3f3f3f3f3f3f;

int n;
std::vector < int > e[N], ec[N];
lint d[N];
std::set < pair > ds;
lint roomBest[N], roomBest1[N];

void setFinal(int v)
{
    if (ds.find(pair(d[v], v)) == ds.end())
        std::cerr << "FRTRYUERT " << d[v] << " " << v << "\n";
    ds.erase(pair(d[v], v));
    for (int i = 0; i < e[v].size(); ++i)
    {
        int t = e[v][i];
        lint l = d[v] + ec[v][i];
        if (roomBest[t] > l)
        {
            roomBest1[t] = roomBest[t];
            roomBest[t] = l;
        } else if (roomBest1[t] > l)
            roomBest1[t] = l;
        if (roomBest1[t] < d[t])
        {
            ds.erase(pair(d[t], t));
            ds.insert(pair(d[t] = roomBest1[t], t));
        }
    }
}

#include <cstdlib>
#include <cstdio>

int travel_plan(int _n, int m, int r[][2], int l[], int k, int p[])
{
    n = _n;
    for (int i = 0; i < m; ++i)
    {
        e[r[i][0]].push_back(r[i][1]);
        e[r[i][1]].push_back(r[i][0]);
        ec[r[i][0]].push_back(l[i]);
        ec[r[i][1]].push_back(l[i]);
    }
    memset(d, 0x3f, sizeof(d));
    memset(roomBest, 0x3f, sizeof(roomBest));
    memset(roomBest1, 0x3f, sizeof(roomBest1));

    for (int i = 0; i < k; ++i)
        ds.insert(pair(d[p[i]] = 0, p[i]));

    while (!ds.empty())
        setFinal(ds.begin()->second);

    return (int)d[0];
}

