#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 20001;
pair <int, int> a[MAXN];
int b[MAXN];
int f[MAXN];
int x[MAXN], y[MAXN];

bool cmpx(int p1, int p2)
{
	return x[p1] < x[p2];
}

bool cmpy(int p1, int p2)
{
	return y[p1] < y[p2];
}

int sx[MAXN];
int sy[MAXN];

int main()
{
	int n, t;
	cin >> n >> t;
	int r = n + 1, bi, bj;
	for (int i= 0; i < n; i++)
	{
		scanf("%d%d", &x[i], &y[i]);
		f[i] = 0;
		sx[i] = sy[i] = i;
	}
	sort(sx, sx + n, cmpx);
	sort(sy, sy + n, cmpy);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if ((x[j] <= x[i]) && (y[j] <= y[i])) f[i]++;
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++) b[j] = 0;
		int c = 0;
		for (int j = 0; j < n; j++)
		{
			if (y[sx[j]] <= y[i]) c++;
			b[sx[j]] += c;
		}
		c = 0;
		for (int j = 0; j < n; j++)
		{
			if (x[sy[j]] <= x[i]) c++;
			b[sy[j]] += c;
		}
		for (int j = 0; j < n; j++)
		{
			if (j == i) continue;
			int tc = f[i] + f[j] - b[j];
			if (tc < 0) tc = -tc;
			tc++;
			if ((tc >= t) && (tc < r)) r = tc, bi = i, bj = j;
		}	
	}
	cout << bi + 1 << " " << bj  + 1 << endl;
	return 0;
}
