#include <iostream>
#include "grader.h"
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 100001;
int mv, md;
vector <pair <int, int> > e[MAXN];
bool w[MAXN];
vector <int> tekpath;
vector <int> anspath;
vector <int> vv;

void dfs(int v, int p, int d)
{
    tekpath.push_back(d);
    if (d > md) mv = v, md = d;
    w[v] = true;
    for (int i = 0; i < e[v].size(); i++)
    {
        if (e[v][i].first != p)
        {
            dfs(e[v][i].first, v , d + e[v][i].second);
        }
    }
    tekpath.pop_back();
}

void dfs2(int v, int p, int d)
{
    tekpath.push_back(d);
    if (v == mv) anspath = tekpath;
    for (int i = 0; i < e[v].size(); i++)e
    {
        if (e[v][i].first != p)
        {
            dfs2(e[v][i].first, v , d + e[v][i].second);
        }
    }
    tekpath.pop_back();
}

int travelTime(int N, int M, int L, int A[], int B[], int T[])
{
    for (int i = 0; i < M; i++)
    {
        e[A[i]].push_back(make_pair(B[i], T[i]));
        e[B[i]].push_back(make_pair(A[i], T[i]));
    }
    for (int i = 0; i < N; i++) w[i] = false;
    int res = 0;
    for (int i = 0; i < N; i++)
    {
        if (w[i]) continue;
        md = -1;
        dfs(i, i, 0);
        int m1 = mv;
        md = -1;
        dfs(m1, m1, 0);
        dfs2(m1, m1, 0);
        int mn = 1000 * 1000 * 1000;
        for (int j = 0; j < anspath.size(); j++) mn = min(mn, max(anspath[j], md - anspath[j]));
        vv.push_back(mn);
        res = max(res, md);
    }
    sort(vv.rbegin(), vv.rend());
    if (vv.size() > 1) res = max(res, vv[0] + vv[1] + L);
    if (vv.size() > 2) res = max(res, vv[1] + vv[2] + 2 * L);
    return res;
}
