#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <queue>
#include <stack>
#include <stdlib.h>
#include <cassert>
#include <bitset>
#include <ctime>
#define mp make_pair
#define pb push_back
#define y1 y1_jkd
#include "grader.h"

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxlog = 20;

struct node
{
	char c;
	int len, prev[maxlog];
	node(){}
	node(char C, int Len)
	{
		 c = C;
		 len = Len;
	}
};

vector<node> a;

void Init()
{
	a.clear();
	a.pb(node('1', 0));
	for (int i = 0; i < maxlog; i++)
		a[0].prev[i] = 0;
}

void TypeLetter(char L)
{
//	cerr << "TYPELETTER\n";
	int top = a.size();
	a.pb(node(L, a[top - 1].len + 1));
	a[top].prev[0] = top - 1;
	for (int i = 1; i < maxlog; i++)
		a[top].prev[i] = a[a[top].prev[i - 1]].prev[i - 1];
//	cerr << "TYPELETTER\n";
}

void UndoCommands(int U)
{
//	cerr << "UNDOCOMMANDS\n";
	int top = a.size();
	a.pb(node('1', a[top - U - 1].len));
	a[top].prev[0] = top - U - 1;
	for (int i = 1; i < maxlog; i++)
		a[top].prev[i] = a[a[top].prev[i - 1]].prev[i - 1];
//	cerr << "UNDOCOMMANDS\n";
}

char GetLetter(int len)
{
//	cerr << "GETLETTER\n";
	int ind = a.size() - 1;
	int ind1 = maxlog - 1;
	while (ind1 >= 0)
	{
		if (a[a[ind].prev[ind1]].len > len)
			ind = a[ind].prev[ind1];
		ind1--;
	}
	while (a[ind].c == '1')
		ind = a[ind].prev[0];
	return a[ind].c;
}

