#include "grader.h"

int cur;
int ct;
int ch[1000001];
int lv[1000001];
int up1[1000001][21];
int up2[1000001][21];

int new_nd(int pr, int prc, int l, char c){
    ct++;
    ch[ct] = c;
    lv[ct] = l;
    up1[ct][0] = pr;
    up2[ct][0] = prc;
    for (int i = 1; i <= 20; i++){
        up1[ct][i] = up1[up1[ct][i - 1]][i - 1];
        up2[ct][i] = up2[up2[ct][i - 1]][i - 1];
    }
    return ct;
}

int getun(int r, int U){
    for (int i = 20; i >= 0; i--){
        if (U >= (1 << i)){
            U -= (1 << i);
            r = up1[r][i];
        }
    }
    return r;
}

char get(int r, int P){
    for (int i = 20; i >= 0; i--){
        if ((lv[r] - (1 << i)) >= P){
            r = up2[r][i];
        }
    }
    return ch[r];
}

void Init() {
    ct = 0;
    cur = 0;
    lv[0] = -1;
}

void TypeLetter(char L) {
    cur = new_nd(cur, cur, lv[cur] + 1, L);
}

void UndoCommands(int U) {
    int k = getun(cur, U);
    cur = new_nd(cur, up2[k][0], lv[k], ch[k]);
}

char GetLetter(int P)  {
    return get(cur, P);
}
