#include <bits/stdc++.h>

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 1179;

int n, m;
bool a[N][N];

bool solve(int l, int r, bool onr)
{
    int c = (onr ? r : l);
    if (l == (r + 1) % n)
    {
        cout << c + 1 << "\n";
        return true;
    }
    static bool vis[2][N][N];
    if (vis[onr][l][r])
        return false;
    vis[onr][l][r] = true;

    int pp = (l + n - 1) % n;
    if (a[c][pp])
    {
        if (solve(pp, r, false))
        {
            cout << c + 1 << "\n";
            return true;
        }
    }
    pp = (r + 1) % n;
    if (a[c][pp])
    {
        if (solve(l, pp, true))
        {
            cout << c + 1 << "\n";
            return true;
        }
    }
    return false;
}

int main()
{
    ios::sync_with_stdio(false);

    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        a[x][y] = a[y][x] = true;
    }

    for (int i = 0; i < n; ++i)
        if (solve(i, i, true))
            return 0;
    cout << "-1\n";

    return 0;
}
