#include <cstdio>
#include <iostream>

using namespace std;

int cs[256];
int ans[100001][10][10];

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int n;
    cin >> n;
    string s;
    cin >> s;
    cs['B'] = 0;
    cs['F'] = 1;
    cs['M'] = 2;
    for (int i = 0; i <= n; i++){
        for (int j = 0; j < 10; j++){
            for (int k = 0; k < 10; k++){
                ans[i][j][k] = -1;
            }
        }
    }
    ans[0][0][0] = 0;
    for (int i = 0; i < n; i++){
        int l = cs[s[i]];
        for (int j = 0; j < 10; j++){
            for (int k = 0; k < 10; k++){
                if (ans[i][j][k] != -1){
                    int j1, k1;
                    if (j == 0){
                        j1 = l * 3 + l + 1;
                        ans[i + 1][j1][k] = max(ans[i + 1][j1][k], ans[i][j][k] + 1);
                    }
                    else{
                        j1 = ((j - 1) % 3) * 3 + l + 1;
                        bool cnt[3] = {false, false, false};
                        cnt[(j - 1) / 3] = true;
                        cnt[(j - 1) % 3] = true;
                        cnt[l] = true;
                        ans[i + 1][j1][k] = max(ans[i + 1][j1][k], ans[i][j][k] + cnt[0] + cnt[1] + cnt[2]);
                    }
                    if (k == 0){
                        k1 = l * 3 + l + 1;
                        ans[i + 1][j][k1] = max(ans[i + 1][j][k1], ans[i][j][k] + 1);
                    }
                    else{
                        k1 = ((k - 1) % 3) * 3 + l + 1;
                        bool cnt[3] = {false, false, false};
                        cnt[(k - 1) / 3] = true;
                        cnt[(k - 1) % 3] = true;
                        cnt[l] = true;
                        ans[i + 1][j][k1] = max(ans[i + 1][j][k1], ans[i][j][k] + cnt[0] + cnt[1] + cnt[2]);
                    }
                }
            }
        }
    }
    int mx = -1;
    for (int i = 0; i < 10; i++){
        for (int j = 0; j < 10; j++){
            if (ans[n][i][j] > mx){
                mx = ans[n][i][j];
            }
        }
    }
    cout << mx;
    return 0;
}
