#include <iostream>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <queue>
#include "grader.h"

typedef long long lint;
const int N = 100500;

const int PROT_I = 0;
const int PROT_MY = 1;
const int PROT_WE = 2;

int findSample(int n, int conf[], int host[], int prot[])
{
	int answer = 0;
	for (int i = n - 1; i >= 1; --i)
	{
		int h = host[i];
		switch (prot[i])
		{
		case PROT_I:
			if (conf[i] >= conf[h])
			{
				answer += conf[i];
				conf[h] = 0;
			} else {
				answer += conf[i];
				conf[h] -= conf[i];
			}
			break;
		case PROT_MY:
			conf[h] += conf[i];
			break;
		case PROT_WE:
			conf[h] = std::max(conf[h], conf[i]);
			break;
		};
	}
	answer += conf[0];
	return answer;
}