#include <iostream>
#include <cstdio>

using namespace std;

int ans[601][601];

int get(int w, int h){
    if (ans[w][h] != -1) return ans[w][h];
    int an = 1e9;
    for (int i = 1; i <= w - 1; i++){
        an = min(an, get(i, h) + get(w - i, h));
    }
    for (int i = 1; i <= h - 1; i++){
        an = min(an, get(w, i) + get(w, h - i));
    }
    ans[w][h] = an;
    return an;
}

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int w, h, n;
    cin >> w >> h >> n;
    for (int i = 1; i <= w; i++){
        for (int j = 1; j <= h; j++){
            ans[i][j] = -1;
        }
    }
    ans[1][1] = 1;
    for (int i = 0; i < n; i++){
        int a, b;
        cin >> a >> b;
        ans[a][b] = 0;
    }
    cout << get(w, h);
    return 0;
}
