#include <bits/stdc++.h>

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 1179;

int n, m;
bool a[N][N];
int vis[2][N][N];

inline int vnext(int v)
{
    return v == n - 1 ? 0 : v + 1;
}

inline int vprev(int v)
{
    return v == 0 ? n - 1 : v - 1;
}

int main()
{
    ios::sync_with_stdio(false);

    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        a[x][y] = a[y][x] = true;
    }

    for (int len = n; len >= 1; --len)
        for (int l = 0; l < n; ++l)
        {
            int r = (l + len - 1) % n;
            for (int onr = 0; onr < 2; ++onr)
            {
                int c = (onr ? r : l);
                if (l == vnext(r))
                {
                    vis[onr][l][r] = 0;
                    continue;
                }

                int pp = vprev(l);
                if (a[c][pp])
                {
                    if (vis[0][pp][r] != -1)
                    {
                        vis[onr][l][r] = 0;
                        continue;
                    }
                }
                pp = vnext(r);
                if (a[c][pp])
                {
                    if (vis[1][l][pp] != -1)
                    {
                        vis[onr][l][r] = 1;
                        continue;
                    }
                }
                vis[onr][l][r] = -1;
            }
        }

    for (int i = 0; i < n; ++i)
        if (vis[0][i][i] != -1)
        {
            int cl = i, cr = i, co = 0;
            while (true)
            {
                cout << (co ? cr : cl) + 1 << "\n";
                if (cl == vnext(cr))
                    break;
                if (vis[co][cl][cr] == 0)
                {
                    co = 0;
                    cl = vprev(cl);
                } else {
                    co = 1;
                    cr = vnext(cr);
                }

            }
            return 0;
        }
    cout << "-1\n";

    return 0;
}
