#include "grader.h"
#include <algorithm>
#include <set>
#include <vector>
using namespace std;

int a[100001];
struct cmp
{
	bool operator()(int x, int y)
	{
		return a[x] < a[y];
	}
};

set <int, cmp> st;
long long cr[3001];

long long int findMaxAttraction(int n, int start, int d, int attraction[]) {
	for (int i = 0; i < n; i++) a[i] = attraction[i];
	long long ans = 0;
	for (int i = 0; i <= start; i++)
	{
		st.clear();
		long long cur = 0;
		for (int j = i; j < start; j++)
		{
			cur += attraction[j];
			st.insert(j);
		}
		for (int j = start; j < n; j++)
		{
			cur += attraction[j];
			st.insert(j);
			int cn = d - (j - i) - min(start - i, j - start);
			if (cn <= 0) break;
			while (!st.empty() && ((int)st.size() > cn))
			{
				cur -= a[*st.begin()];
				st.erase(st.begin());
			}
			ans = max(ans, cur);
		}
	}
	return ans;
}
