#include <iostream>

typedef long long ll;

ll n;

bool f(ll x, ll y)
{
	if (x < 1 || y < 1 || x > n || y > n)
		return false;
	std::cout << "examine " << x << " " << y << "\n";
	std::cout.flush();
	std::string s;
	std::cin >> s;
	return s == "true";
}

ll x, y;

int main()
{
	std::cin >> x >> y;
	ll l = x + 1, r;
	for (ll i = 1;; i <<= 1)
		if (!f(x + i, y))
		{
			r = x + i;
			break;
		}
	while (l < r)
	{
		ll mm = (l + r) / 2;
		if (f(mm, y))
			r = mm;
		else
			l = mm + 1;
	}
	x = l;
	
    l = x + 1;
	for (ll i = 1;; i <<= 1)
		if (!f(x, y + i))
		{
			r = y + i;
			break;
		}
	while (l < r)
	{
		ll mm = (l + r) / 2;
		if (f(x, mm))
			r = mm;
		else
			l = mm + 1;
	}
	y = l;
	
    r = x;
	for (ll i = 1;; i <<= 1)
		if (!f(x - i, y))
		{
			l = x - i;
			break;
		}
	while (l < r)
	{
		ll mm = (l + r + 1) / 2;
		if (f(x, mm))
			r = mm - 1;
		else
			l = mm;
	}
	ll m = x - l;
	
	while (f(x + m, y + m))
	{
		x += m;
		y += m;
	}
	
	while (f(x + m * 2, y))
		x += m * 2;
	while (f(x, y + m * 2))
		y += m * 2;
	std::cout << "solution " << x - m * 2 - m / 2 << " " << y - m * 2 - m / 2 <<"\n";
	return 0;
}