#include "grader.h"
#include <vector>
#include <set>

using namespace std;

long long mn1[100001];
long long mn2[100001];
bool used[100001];
bool out[100001];
vector<pair<long long, int> > edge[100001];

int travel_plan(int n, int m, int R[][2], int L[], int k, int P[]) {
    for (int i = 0; i < m; i++){
        int a = R[i][0], b = R[i][1];
        long long w = L[i];
        edge[a].push_back(make_pair(w, b));
        edge[b].push_back(make_pair(w, a));
    }
    for (int i = 0; i < k; i++){
        out[P[i]] = true;
    }
    set<pair<long long, int> > st;
    for (int i = 0; i < n; i++){
        mn1[i] = mn2[i] = -1;
        if (out[i]){
            used[i] = true;
            st.insert(make_pair(0, i));
        }
    }
    while(!st.empty()){
        pair<long long, int> a = *st.begin();
        st.erase(a);
        if (used[a.second]) continue;
        used[a.second] = true;
        if (a.second == 0){
            return a.first;
        }
        for (int i = 0; i < edge[a.second].size(); i++){
            pair<long long, int> v = edge[a.second][i];
            if (!used[v.second] && !out[v.second]){
                int k = a.first + v.first;
                if (mn1[v.second] == -1 || mn1[v.second] > k){
                    mn2[v.second] = mn1[v.second];
                    mn1[v.second] = k;
                    if (mn2[v.second] != -1){
                        st.insert(make_pair(mn2[v.second], v.second));
                    }
                }
                else if(mn2[v.second] == -1 || mn2[v.second] > k){
                    mn2[v.second] = k;
                    st.insert(make_pair(mn2[v.second], v.second));
                }
            }
        }
    }
    return m/2;
}
