#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

pair<int, int> p[20001];
int y[20001];
int a[20001];
int sm[20001];
int b[20001];
int n;

bool cmp(int a, int b){
    return p[a] < p[b];
}


void st(int p, int x){
    for (int i = p; i <= n; i = (i | (i - 1)) + 1){
        sm[i] += x - b[p];
    }
    b[p] = x;
}

int sum(int p){
    int ans = 0;
    for (int i = p; i > 0; i = i & (i - 1)){
        ans += sm[i];
    }
    return ans;
}

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int t;
    scanf("%d%d", &n, &t);
    for (int i = 0; i < n; i++){
        scanf("%d%d", &p[i].first, &p[i].second);
        a[i] = i;
        y[i] = p[i].second;
    }
    sort(a, a + n, cmp);
    sort(y, y + n);
    for (int i = 0; i < n; i++){
        p[i].second = lower_bound(y, y + n, p[i].second) - y + 1;
    }
    int mn = -1;
    int mni = -1, mnj = -1;
    for (int i = 0; i < n; i++){
        int y = p[a[i]].second;
        st(y, 1);
        for (int j = i + 1; j < n; j++){
            st(p[a[j]].second, 1);
            int k;
            if (p[a[j]].second < y)
                k = sum(y) - sum(p[a[j]].second - 1);
            else
                k = sum(p[a[j]].second) - sum(y - 1);
            if ((mn == -1 || k < mn) && k >= t){
                mn = k;
                mni = a[i];
                mnj = a[j];
            }
        }
        st(y, 0);
        for (int j = i + 1; j < n; j++)
            st(p[a[j]].second, 0);
    }
    printf("%d %d", mni + 1, mnj + 1);
    return 0;
}
