#include <iostream>
#include <cstdio>
#include <set>
#include <queue>

using namespace std;

long long w[2001];
long long t[101];
int pl[2001];
set<int> st;

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++){
        cin >> t[i];
        st.insert(i);
    }
    for (int i = 1; i <= m; i++){
        cin >> w[i];
    }
    queue<int> q;
    long long ans = 0;
    for (int i = 0; i < 2 * m; i++){
        int c;
        cin >> c;
        if (c > 0){
            if (!st.empty()){
                int k = *st.begin();
                st.erase(k);
                pl[c] = k;
                ans += w[c] * t[k];
            }
            else{
                q.push(c);
            }
        }
        else{
            c = -c;
            if (!q.empty()){
                pl[q.front()] = pl[c];
                ans += w[q.front()] * t[pl[c]];
                q.pop();
            }
            else{
                st.insert(pl[c]);
            }
        }
    }
    cout << ans;
    return 0;
}
