#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

int a[251][251];
int pr[251][251];

struct rect{

    int x1, y1, x2, y2;

    rect(){
    }

    rect(int x, int y, int xc, int yc){
        x1 = x;
        y1 = y;
        x2 = xc;
        y2 = yc;
    }
};

int get(int x1, int y1, int x2, int y2){
    return pr[x2][y2] - pr[x2][y1 - 1] - pr[x1 - 1][y2] + pr[x1 - 1][y1 - 1];
}

bool ins(rect a, rect b){
    return (min(a.x2, b.x2) - max(a.x1, b.x1) >= 0) && (min(a.y2, b.y2) - max(a.y1, b.y1) >= 0);
}

int per(rect a){
    return 2 * (a.x2 - a.x1 + 1) + 2 * (a.y2 - a.y1 + 1);
}

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int l, w, n, k;
    cin >> l >> w >> n >> k;
    for (int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        a[x][y]++;
    }
    for (int i = 1; i <= l; i++){
        for (int j = 1; j <= w; j++){
            pr[i][j] = pr[i - 1][j] + pr[i][j - 1] - pr[i - 1][j - 1] + a[i][j];
        }
    }
    vector<rect> ans;
    for (int u = 1; u <= l; u++){
        for (int d = u; d <= l; d++){
            int r1 = 0;
            for (int l1 = 1; l1 <= w; l1++){
                r1 = max(r1, l1 - 1);
                while (r1 <= w && get(u, l1, d, r1) < k) r1++;
                if (get(u, l1, d, r1) > k) r1--;
                if (get(u, l1, d, r1) == k){
                    ans.push_back(rect(u, l1, d, r1));
                }
            }
        }
    }
    int mn = 1e9;
    for (int i = 0; i < ans.size(); i++){
        for (int j = i + 1; j < ans.size(); j++){
            if (!ins(ans[i], ans[j])){
                mn = min(mn, per(ans[i]) + per(ans[j]));
            }
        }
    }
    cout << mn;
    return 0;
}
