#include "grader.h"

int a[5001];
int b[5001];
int c[5001];
int d[5001];
int n;

bool check(int x){
    int k = tryCombination(a);
    return (k > x) || (k == -1);
}

int get(int l, int r, int x){
    if (l == r - 1) return l;
    int m = (l + r) / 2;
    for (int i = 0; i < l; i++){
        a[i] = 1 - b[x];
    }
    for (int i = l; i < m; i++){
        a[i] = b[x];
    }
    for (int i = m; i < n; i++){
        a[i] = 1 - b[x];
    }
    for (int i = 0; i < x; i++){
        a[c[i]] = b[i];
    }
    if (check(x)){
        return get(l, m, x);
    }
    else{
        return get(m, r, x);
    }
}

void exploreCave(int N) {
    n = N;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            a[j] = 0;
        }
        for (int j = 0; j < i; j++){
            a[c[j]] = b[j];
        }
        if (check(i)){
            b[i] = 0;
        }
        else{
            b[i] = 1;
        }
        c[i] = get(0, n, i);
    }
    for (int i = 0; i < n; i++){
        a[c[i]] = b[i];
        d[c[i]] = i;
    }
    answer(a, d);
}
