#include "grader.h"
#include <algorithm>

using namespace std;

const int LG = 20;
const int MAXN = 100001;

struct node
{
	char cp;
	node* p[LG];
	int len;
};

node* root[MAXN];


int n;


void Init() {
	root[0] = new node();
	for (int i = 0; i < LG; i++) root[0]->p[i] = root[0];
	root[0]->cp = '#';
	root[0]->len = 0;
	n = 1;
}



void TypeLetter(char L) {
	root[n] = new node;
	root[n]->p[0] = root[n - 1];
	for (int i = 1; i < LG; i++) root[n]->p[i] = root[n]->p[i - 1]->p[i - 1];
	root[n]->len = root[n - 1]->len + 1;
	root[n]->cp = L;
	n++;
}

void UndoCommands(int U) {
	root[n] = root[n - 1 - U];
	n++;
}

char GetLetter(int P)  {
    int p = root[n-1]->len - P;
	node* cur = root[n-1];
	for (int i = LG - 1; i >= 0; i--)
	{
		if (p > (1 << i))
		{
			p -= (1 << i);
			cur = cur->p[i];
		}
	}
	return cur->cp;
}
