#include <bits/stdc++.h>

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 1024;

int n, m, a, b, c, d;
int s[N][N], s2[N*2-1][N*2-1];

void build()
{
    for (int i = N*2-2; i >= 0; --i)
        for (int j = N*2-2; j >= 0; --j)
        {
            if (i < N-1)
                s2[i][j] = min(s2[i*2+1][j], s2[i*2+2][j]);
            else if (j < N-1)
                s2[i][j] = min(s2[i][j*2+1], s2[i][j*2+2]);
        }
}

int getMin2(int d, int y1, int y2, int c=0, int cy1=0, int cy2=N-1)
{
    if (y1 > cy2 || y2 < cy1)
        return IINF;
    if (y1 <= cy1 && cy2 <= y2)
        return s2[d][c];
    return min(getMin2(d, y1, y2, c*2+1, cy1, (cy1+cy2)/2),
               getMin2(d, y1, y2, c*2+2, (cy1+cy2)/2+1, cy2));
}

int getMin(int x1, int y1, int x2, int y2, int c=0, int cx1=0, int cx2=N-1)
{
    if (x1 > cx2 || x2 < cx1)
        return IINF;
    if (x1 <= cx1 && cx2 <= x2)
        return getMin2(c, y1, y2);
    return min(getMin(x1, y1, x2, y2, c*2+1, cx1, (cx1+cx2)/2),
               getMin(x1, y1, x2, y2, c*2+2, (cx1+cx2)/2+1, cx2));
}

int main()
{
    ios::sync_with_stdio(false);

    cin >> m >> n >> b >> a >> d >> c;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            int x;
            cin >> x;
            s[i+1][j+1] = s[i+1][j] + s[i][j+1] - s[i][j] + x;
        }

    for (int i = 0; i <= n - c; ++i)
        for (int j = 0; j <= m - d; ++j)
            s2[i+N-1][j+N-1] = s[i+c][j+d] + s[i][j] - s[i][j+d] - s[i+c][j];

    build();

    int ax1, ay1, aa = 0, zz;
    for (int i = 0; i <= n-a; ++i)
        for (int j = 0; j <= m-b; ++j)
        {
            int ss = s[i+a][j+b] + s[i][j] - s[i][j+b] - s[i+a][j];
            int ssa = getMin(i+1, j+1, i+a-1-c, j+b-1-d);
            if (ss - ssa > aa)
            {
                aa = ss - ssa;
                zz = ssa;
                ax1 = i;
                ay1 = j;
            }
        }

    for (int i = ax1+1; i <= ax1+a-1-c; ++i)
        for (int j = ay1+1; j <= ay1+b-1-d; ++j)
            if (s2[i+N-1][j+N-1] == zz)
            {
                cout << ay1+1 << " " << ax1+1 << "\n";
                cout << j+1 << " " << i+1 << "\n";
                return 0;
            }
    return 0;
}