#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 250001;
const int MAXR = 25001;
const int PS = 450;
vector <int> e[MAXN];
int rs[MAXN];
vector <int> ns[MAXN];
vector <pair <int, int> > a[MAXN];
int pr1[450][MAXR], pr2[450][MAXR];
int bis[MAXR];
vector <pair <int, int> > all;

int cn = 0;
void dfs(int v, int p)
{
	int st = cn;
	ns[rs[v]].push_back(cn++);
	for (int i = 0; i < e[v].size(); i++)
	{
		if (e[v][i] != p)
		{
			dfs(e[v][i], v);
		}
	}
	if (cn == st)  return;
	a[rs[v]].push_back(make_pair(st + 1, 1));
	a[rs[v]].push_back(make_pair(cn, -1));
	all.push_back(make_pair(st + 1, rs[v] + 1));
	all.push_back(make_pair(cn, -rs[v] - 1));
}

int curs[MAXR];
int prv[MAXN];

int main()
{
	int n, r, q;
	cin >> n >> r >> q;
	for (int i = 0; i < n; i++)
	{
		if (i != 0)
		{
			int p;
			cin >> p;
			p--;
			e[i].push_back(p);
			e[p].push_back(i);
		}
		cin >> rs[i];
		rs[i]--;
	}
	dfs(0,0);
	for (int i = 0; i < r; i++)
	{
		for (int j = 0; j < ns[i].size(); j++)
		{
			rs[ns[i][j]] = i;
		}
	}
	int bs = 0;
	for (int i = 0; i < r; i++)
	{
		sort(a[i].begin(), a[i].end());
		sort(ns[i].begin(), ns[i].end());
	}
	sort(all.begin(), all.end());
	for (int i = 0; i < r; i++)
	{
		bis[i] = -1;
		if (ns[i].size() > PS)
		{
			for (int j = 0; j < r; j++) pr1[bs][j] = pr2[bs][j] = 0;
			bis[i] = bs;
			int p = 0, cur = 0;
			for (int j = 0; j < n; j++)
			{
				while ((p < a[i].size()) && (a[i][p].first <= j))
				{
					cur += a[i][p++].second;
				}
				pr1[bs][rs[j]] += cur;
			}
			p = 0;
			for (int j = 0; j < r; j++) curs[j] = prv[j] = 0;
			for (int j = 0; j < ns[i].size(); j++)
			{
				while ((p != all.size()) && (all[p].first <= ns[i][j]))
				{
					int md = abs(all[p].second) - 1;
					pr2[bs][md] += curs[md] * (j - prv[md]);
					if (all[p].second > 0)
					{
						curs[md]++;
					}
					else curs[md]--;
					prv[md] = j;
					p++;
				}
			}
			for (int j = 0; j < r; j++)
			{
				pr2[bs][j] += (ns[i].size() - prv[j]) * curs[j];
			}
			bs++;
		}
	}
	for (int i = 0; i < q; i++)
	{
		int cc, b;
		cin >> cc >> b;
		cc--, b--;
		if (bis[cc] != -1)
		{
			cout << pr1[bis[cc]][b] << endl;
			cout.flush();
		}
		else if (bis[b] != -1)
		{
			cout << pr2[bis[b]][cc] << endl;
			cout.flush();
		}
		else
		{
			int p = 0, res = 0, cur = 0;
			for (int j = 0; j < ns[b].size(); j++)
			{
				while ((p != a[cc].size()) && (a[cc][p].first <= ns[b][j]))
				{
					cur += a[cc][p++].second;
				}
				res += cur;
			}
			cout << res << endl;
			cout.flush();
		}
	}
	return 0;
}