#include "grader.h"


int n;
const int MAXN = 1501;
int g[MAXN];
int c[MAXN];
int a[MAXN][MAXN];
void initialize(int N) {
	n = N;
	for (int i = 0; i < n; i++)
	{
		g[i] = i;
		c[i] = 1;
		for (int j = 0; j < n; j++)
		{
			a[i][j] = 0;
		}
	}
}

int hasEdge(int u, int v) {
	a[g[u]][g[v]]++;
    a[g[v]][g[u]]++;
    if (a[g[u]][g[v]] < c[g[u]] * c[g[v]]) return 0;
	int gu = g[u], gv = g[v];
	for (int i = 0; i < n; i++)
	{
		if (g[i] == gv)
		{
			g[i] =  gu;
		}
	}
	c[gu] += c[gv];
	for (int i = 0; i < n; i++)
	{
		a[gu][i] += a[gv][i];
	}
	for (int i = 0; i < n; i++)
	{
		a[i][gu] += a[i][gv];
	}
	return 1;
}
