#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 300;
const int INF = 1000 * 1000;

int a[MAXN][MAXN];
int f1[MAXN], f2[MAXN];
int k, n, m;
int c[MAXN];
int ans = INF;

void calc()
{
	for (int i = 0; i <= m; i++) f1[i] = f2[i] = INF;
	for (int l = 0; l < n; l++)
	{
		for (int i = 0; i < m; i++) c[i] = 0;
		for (int r = l; r < n; r++)
		{
			for (int i = 0; i < m; i++) c[i] += a[r][i];
			int rg = 0, cur = 0;
			for (int lg = 0; lg < m; lg++)
			{
				while ((cur < k) && (rg < m)) 
				{
					cur += c[rg++];
				}
				if (cur == k)
				{
					f1[rg] = min(f1[rg], (r - l + 1) + (rg - lg));
					f2[lg] = min(f2[lg], (r - l + 1) + (rg - lg));
				}
				cur -= c[lg];
			}
		}
	}
	for (int i = 0; i < m; i++) f1[i + 1] = min(f1[i + 1], f1[i]);
	for (int i = m; i > 0; i--) f2[i - 1] = min(f2[i - 1], f2[i]);
	for (int i = 0; i <= m; i++) ans = min(ans, f1[i] + f2[i]);
}

int main()
{
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			a[i][j] = 0;
		}
	}
	int v;
	cin >> v >> k;
	for (int i = 0; i < v; i++)
	{
		int x, y;
		cin >> x >> y;
		a[x - 1][y - 1]++;
	}
	calc();
	swap(n, m);
	for (int i = 0; i < max(n, m); i++)
	{
		for (int j = 0; j < i; j++)
		{
			swap(a[i][j], a[j][i]);
		}
	}
	calc();	
	if (ans == INF) ans = -1;
	cout << ans * 2 << endl;
	return 0;
}