#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const int MAXN = 101;
const ll INF = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;

int n, k;	
ll f[MAXN][MAXN][MAXN];
ll d[MAXN];
ll cn[MAXN];

vector <pair <int, ll> > e[MAXN];
ll cf[MAXN];
ll ht[MAXN];
ll nwf[MAXN];

void dfs(int v, int p, int h, ll nf)
{
	ht[h] = nf;
	for (int i = 0; i < e[v].size(); i++)
	{
		dfs(e[v][i].first, v, h + 1, nf + e[v][i].second);
	}
	for (int les = 0; les <= h; les++)
	{
		ll dd = ht[h] - ht[les];
		for (int cnt = 0; cnt <= k; cnt++)
		{
			//Putmill
			for (int i = 0; i <= cnt; i++) cf[i] = 0;
			cf[0] = INF;
			for (int i = 0; i < e[v].size(); i++)
			{
				for (int j = 0; j <= cnt; j++) nwf[j] = INF;
				for (int j = cnt; j >= 0; j--)
				{
					for (int l = 0; l + j <= cnt; l++)
					{
						nwf[l + j] = min(nwf[l + j], cf[l] + f[e[v][i].first][h][j]);
					}
				}
				for (int j = 0; j <= cnt; j++) cf[j] = nwf[j];
			}
			f[v][les][cnt] = cf[cnt];


			//notputmill
			for (int i = 0; i <= cnt; i++) cf[i] = cn[v] * dd;
			for (int i = 0; i < e[v].size(); i++)
			{
				for (int j = 0; j <= cnt; j++) nwf[j] = INF;
				for (int j = cnt; j >= 0; j--)
				{
					for (int l = 0; l + j <= cnt; l++)
					{
						nwf[l + j] = min(nwf[l + j], cf[l] + f[e[v][i].first][les][j]);
					}
				}
				for (int j = 0; j <= cnt; j++) cf[j] = nwf[j];
			}
			f[v][les][cnt] = min(f[v][les][cnt], cf[cnt]);
		}
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin >> n >> k;
	for (int i = 1; i <= n; i++)
	{
		cin >> cn[i];
		int vd;
		ll dst;
		cin >> vd >> dst;
		e[vd].push_back(make_pair(i, dst));
	}
	cn[0] = 0;
	dfs(0, 0, 0, 0);
	cout << f[0][0][k] << endl;
	return 0;
}