#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h>
#include <list>
#include <cstring>
using namespace std;

#define name ""
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(ll i = 0; i < (ll)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC
#define inb push_back

struct __isoff{
	__isoff(){
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, freopen("test.txt", "w", stderr);
		//else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		srand(time(0));
		//srand('C' + 'T' + 'A' + 'C' + 'Y' + 'M' + 'B' + 'A');
	}
	~__isoff(){
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 31;
const ull p2 = 29;
const double eps = 1e-8;
const double pi = acos(-1.0);

const ll inf = 1e17 + 7;
const int infi = 1e9 + 7;
const ll dd = 2e6 + 7;
const ll mod = 1e9 + 7;

#include <wall.h>

int F[dd * 4], L[dd * 4], R[dd * 4], ZL[dd * 4], ZR[dd * 4], H[dd];

void push(int v){
	if(ZL[v]){
		ZL[v * 2] = ZL[v * 2 + 1] = 1;

		if(L[v * 2] != -infi)
			L[v * 2] = min(L[v * 2], L[v]);
		else
			L[v * 2] = L[v];
		if(L[v * 2 + 1] != -infi)
			L[v * 2 + 1] = min(L[v * 2 + 1], L[v]);
		else
			L[v * 2 + 1] = L[v];
		
		if(ZR[v * 2] && R[v * 2] > L[v])
			ZR[v * 2] = 0, R[v * 2] = infi;
		if(ZR[v * 2 + 1] && R[v * 2 + 1] > L[v])
			ZR[v * 2 + 1] = 0, R[v * 2 + 1] = infi;

		R[v * 2] = min(R[v * 2], L[v]);
		R[v * 2 + 1] = min(R[v * 2 + 1], L[v]);

		F[2 * v] = min(F[2 * v], L[v]);
		F[2 * v + 1] = min(F[2 * v + 1], L[v]);

		L[v] = -infi;
		ZL[v] = 0;	
	}
	if(ZR[v]){
		ZR[v * 2] = ZR[v * 2 + 1] = 1;

		if(ZL[v * 2] && L[v * 2] < R[v])
			ZL[v * 2] = 0, L[v * 2] = -infi;
		if(ZL[v * 2 + 1] && L[v * 2 + 1] < R[v])
			ZL[v * 2 + 1] = 0, L[v * 2 + 1] = -infi;

		if(R[v * 2] != infi)
			R[v * 2] = max(R[v * 2], R[v]);
		else
			R[v * 2] = R[v];
		if(R[v * 2 + 1] != infi)
			R[v * 2 + 1] = max(R[v * 2 + 1], R[v]);
		else
			R[v * 2 + 1] = R[v];

		F[2 * v] = max(F[2 * v], R[v]);
		F[2 * v + 1] = max(F[2 * v + 1], R[v]);

		R[v] = infi;
		ZR[v] = 0;	
	}
}

void build(int v, int l, int r){
	if(l == r){
		F[v] = H[l];
		return;
	}
	L[v] = -infi;
	R[v] = infi;
	int s = (l + r) / 2;
	build(v * 2, l, s);
	build(v * 2 + 1, s + 1, r);
}

int get(int v, int l, int r, int x){
	if(l == r)
		return F[v];
	int s = (l + r) / 2;
	push(v);
	if(x <= s)
		return get(v * 2, l, s, x);
	else
		return get(v * 2 + 1, s + 1, r, x);
}

void up(int v, int l, int r, int lq, int rq, int tm, int ss){
	if(lq > rq)
		return;
	if(l == lq && r == rq){
		if(tm < 0){
			ZL[v] = 1;
			if(L[v] != -infi)
				L[v] = min(L[v], ss);
			else
				L[v] = ss;
			if(ZR[v] && R[v] > ss)
				ZR[v] = 0, R[v] = infi;
			F[v] = min(F[v], ss);
		}
		else{
			ZR[v] = 1;
			if(R[v] != infi)
				R[v] = max(R[v], ss);
			else
				R[v] = ss;
			if(ZL[v] && L[v] < ss)
				ZL[v] = 0, L[v] = -infi;
			F[v] = max(F[v], ss);
		}
		return;
	}
	push(v);
	int s = (l + r) / 2;
	up(v * 2, l, s, lq, min(rq, s), tm, ss);
	up(v * 2 + 1, s + 1, r, max(lq, s + 1), rq, tm, ss);
}

void buildWall(int n, int k, int op[], int left[], int right[], int height[], int finalHeight[]){
	build(1, 0, n - 1);
	forn(i, k){
		if(op[i] == 1){
			up(1, 0, n - 1, left[i], right[i], 1, height[i]);
		}
		else{
			up(1, 0, n - 1, left[i], right[i], -1, height[i]);
		}
	}
	forn(i, n)
		finalHeight[i] = get(1, 0, n - 1, i);
}
/*
int main(){
	int n, k;
	cin >> n >> k;
	build(1, 0, n - 1);
	forn(i, k){
		int op, left, right, height;
		cin >> op >> left >> right >> height;
		if(op == 1){
			up(1, 0, n - 1, left, right, 1, height);
		}
		else{
			up(1, 0, n - 1, left, right, -1, height);
		}
	//forn(i, n)
	//	cout << get(1, 0, n - 1, i) << ' ';
	//cout << '\n';

	}
	forn(i, n)
		cout << get(1, 0, n - 1, i) << ' ';
}*/