#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 500001;

int ci;

vector <pair <int, int> > e[MAXN]; 
int x[MAXN], y[MAXN];

bool cmp(pair <int, int> p1, pair <int, int> p2)
{
	if (x[p2.first] < x[ci]) return false;
	if (x[p1.first] < x[ci]) return true;
	if (y[p2.first] > y[ci]) return false;
	if (y[p1.first] > y[ci]) return true;
	if (x[p2.first] > x[ci]) return false;
	if (x[p1.first] > x[ci]) return true;
	return false;
}


vector <int> cur;

bool cmparr(int i1, int i2)
{
	return make_pair(x[i1], y[i1]) < make_pair(x[i2], y[i2]);
}
int arr[MAXN];
vector <int> god;

void rem(int t, int id)
{
	for (int i = 0; i < e[t].size(); i++)
	{
		if (e[t][i].second  == id)
		{
			for (int j = i; j + 1 < e[t].size(); j++)
			{
				e[t][j] = e[t][j + 1];
			}
			e[t].pop_back();
		}
	}
}

int aw[MAXN], bw[MAXN];

int main()
{
	//freopen("inpt.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, m;
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		scanf("%d%d", &x[i], &y[i]);
		arr[i - 1] = i;
	}	
	sort(arr, arr + n, cmparr);
	scanf("%d", &m);
	for (int i= 0; i < m; i++)
	{
		int a, b;
		scanf("%d%d", &a, &b);
		aw[i] = a, bw[i] = b;
		e[a].push_back(make_pair(b, i));
		e[b].push_back(make_pair(a, i));
	}
	for (int i = 1; i <= n; i++)
	{
		ci = i;
		sort(e[i].begin(), e[i].end(), cmp);
	}
	int isp = 0;
	while (isp < n)
	{
		int sp = arr[isp];
		if (e[sp].size() == 0)
		{
			isp++;
			continue;
		}
		bool stt = true;
		int id = e[sp][1 % e[sp].size()].second, tw = sp;
		while ((tw != sp) || stt)
		{
			stt = false;
			int vi;
			for (int i = 0; i < e[tw].size(); i++)
			{
				if (e[tw][i].second == id)
				{
					vi = (i + 1) % e[tw].size();
				}
			}
			id = e[tw][vi].second;
			tw = e[tw][vi].first;
			cur.push_back(id);
		}
		sort(cur.begin(), cur.end());
		for (int i = 0; i <	cur.size(); i++)
		{
			if ((i == 0) || (cur[i] != cur[i - 1])) rem(aw[cur[i]], cur[i]), rem(bw[cur[i]], cur[i]);
			else
			{
				god.push_back(cur[i] + 1);
			}
		}
		cur.clear();
	}
	cout << god.size() << endl;
	sort(god.begin() ,god.end());
	for (int i = 0; i < god.size(); i++) cout << god[i] << endl;	
	return 0;
}