#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 6001;
vector <pair <int, int> > e[MAXN];

int a, b;
pair <pair <int, int>, int> resdfs;
void dfs(int v, int p, pair <pair  <int, int>, int> cur)
{
	pair <pair <int, int>, int> nc;
	if (v == b) 
	{
		resdfs = cur;
		return;
	}
	for (int i = 0; i < e[v].size(); i++)
	{
		if (e[v][i].first == p) continue;
		if (e[v][i].second > nc.second)
		{
			nc = make_pair(make_pair(v, e[v][i].first), e[v][i].second);
		}
		else nc = cur;
		dfs(e[v][i].first, v, nc);
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, w, c;
	cin >> n >> w;
	int cnt = 0;
	for (int i = 0; i < w; i++)
	{
		cin >> a >> b >> c;
		resdfs = make_pair(make_pair(-1, -1), 1000000);
		dfs(a, a, make_pair(make_pair(-1, -1), -1));
		if (resdfs.second > c)
		{
			cnt++;
			if (resdfs != make_pair(make_pair(-1, -1), 1000000))
			{
				int v1 = resdfs.first.first, v2 = resdfs.first.second;
				e[v1].erase(find(e[v1].begin(), e[v1].end(), make_pair(v2, resdfs.second)));
				e[v2].erase(find(e[v2].begin(), e[v2].end(), make_pair(v1, resdfs.second)));
				cnt--;
			}
			e[a].push_back(make_pair(b, c));
			e[b].push_back(make_pair(a, c));
		}
		int sm = 0;
		for (int i = 1; i <= n; i++)
		{
			for (int j = 0; j < e[i].size(); j++)
			{
				sm += e[i][j].second;
			}
		}
		if (cnt == n - 1) cout << sm / 2 << endl;
		else cout << -1 << endl;
	}
	return 0;
}