#include "grader.h"
#include <vector>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

const static int MAXN = 1002;
static vector <int> e[MAXN];

void enc(int x)
{
	for (int i = 0; i < 10; i++)
	{ 
		encode_bit(x % 2);
		x /= 2;
	}
}

void encode(int nv, int nh, int ne, int *v1, int *v2){
	int d[MAXN];
	bool w[MAXN];
	w[MAXN - 1] = true;
	for (int i = 0; i < nv; i++) e[i].clear();
	for (int i = 0; i < ne; i++)
	{
		e[v1[i]].push_back(v2[i]);
		e[v2[i]].push_back(v1[i]);
	}
	for (int i = 0; i < nh; i++)
	{
		for (int j = 0; j < nv; j++) d[j] = MAXN - 1, w[j] = false;
		d[i] = 0;
		for (int j = 0; j < nv; j++)
		{
			int ml = 1000;
			for (int l = 0; l < nv; l++)
			{
				if (w[l]) continue;
				if (w[ml] || (d[l] < d[ml])) ml = l;
			}
			w[ml] = true;
			for (int l = 0; l < e[ml].size(); l++)
			{
				d[e[ml][l]] = min(d[e[ml][l]], d[ml] + 1);
			}
		}
		for (int j = 0; j < nv; j++)
		{
			enc(d[j]);
		}
	}
}

int gt()
{
	int v = 0, sp = 1;
	for (int i = 0; i < 10; i++)
	{
		v = v + sp * decode_bit();
		sp *= 2;
	}
	return v;
}

void decode(int nv, int nh) {
	for (int i= 0; i < nh; i++)
	{
		for (int j = 0; j < nv; j++)
		{
			hops(i, j, gt());
		}
	}
}
