#include "grader.h"  
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 400001;
int rmq[MAXN];
int p[MAXN];
int rs[MAXN];
int h[MAXN];
int tp[MAXN];
vector <int> e[MAXN];

int find_rmq(int v, int l, int r, int fn, bool del)
{
	if (del) rmq[v]--;
	if (l == r)
	{
		return l;
	}
	else
	{
		if (rmq[v * 2 + 1] > fn) return find_rmq(v * 2 + 1, l, (l + r) / 2, fn, del);
		else return find_rmq(v * 2 + 2, (l + r) / 2 + 1, r, fn - rmq[v * 2 + 1], del);
	}
}

void create_rmq(int v, int l, int r)
{
	if (l != r)
	{
		create_rmq(v * 2 + 1, l, (l + r) / 2);
		create_rmq(v * 2 + 2, (l + r) / 2 + 1, r);
	}
	rmq[v] = (r - l + 1);
}

int GetBestPosition(int N, int C, int R, int *K, int *S, int *E) {
	for (int i = 0; i < N; i++) p[i] = i;
	int id = N;
	create_rmq(0, 0, N - 1);
	for (int i = 0; i < C; i++)
	{

		int cnt = E[i] - S[i];
		int b = find_rmq(0, 0, N - 1, S[i], false);
		e[id].push_back(p[b]);
		p[b] = id;
		for (int j = 0;j < cnt; j++)
		{
			e[id].push_back(p[find_rmq(0, 0, N - 1, S[i] + 1, true)]);
		}
		id++;
	}
	int r = 0, r2 = 0;
	K[N - 1] = R;
	for (int i = 0; i < N; i++)
	{
		if (K[i] > R) tp[i] = 1;
		else tp[i] = 2;
		h[i] = 0;
		rs[i] = i;
	}
	for (int i = N; i < id; i++)
	{
		tp[i] = 2;
		h[i] = -2;
		for (int j = 0; j < e[i].size(); j++) 
		{
			if (h[e[i][j]] >= h[i])
			{
				h[i] = h[e[i][j]] + 1;
				rs[i] = rs[e[i][j]];
			}
		}
		for (int j = 0; j < e[i].size() - 1; j++)
		{
			if (tp[e[i][j]] != 2) tp[i] = 0;
		}
		if (tp[i] == 2) tp[i] = tp[e[i][e[i].size() - 1]];
	    if ((tp[i] != 0) && (r < h[i]))
		{
			r = h[i];
			r2 = rs[i];
		}
 	}
	return r2;
}
