#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 20001;
pair <int, int> a[MAXN];
int b[MAXN];
int f[MAXN];
int x[MAXN], y[MAXN];

bool cmpx(int p1, int p2)
{
	return make_pair(x[p1], y[p1]) < make_pair(x[p2], y[p2]);
}

bool cmpy(int p1, int p2)
{
	return make_pair(y[p1], x[p1]) < make_pair(y[p2], x[p2]);
}

int sx[MAXN];
int sy[MAXN];
int n, t;
int r = 100000000 + 1, bi, bj;

int main()
{
	scanf("%d%d", &n, &t);
	for (int i= 0; i < n; i++)
	{
		scanf("%d%d", &x[i], &y[i]);
	}
	for (int i = 0; i < n; i++) sx[i] = sy[i] = i;
	stable_sort(sx, sx + n, cmpx);
	stable_sort(sy, sy + n, cmpy);
	for (int i = 0; i < n; i++)
	{
		f[i] = 0;
		for (int j = 0; j < n; j++)
		{
			if ((x[j] <= x[i]) && (y[j] <= y[i]))
			{
				f[i]++;
			}
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++) b[j] = 0;
		int c = 0;
		for (int j = 0; j < n; j++)
		{
			if (y[sx[j]] <= y[i]) c++;
			b[sx[j]] += c;
		}
		c = 0;
		for (int j = 0; j < n; j++)
		{
			if (x[sy[j]] <= x[i]) c++;
			b[sy[j]] += c;
		}
		for (int j = i + 1; j < n; j++)
		{
			if (j == i) continue;
			int tc = abs(f[j] + f[i] - b[j]) + 1;
			if ((tc >= t) && (tc < r)) r = tc, bi = i, bj = j;
		}	
	}
	cout << bi + 1 << " " << bj + 1 << endl;
	return 0;
}
