#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
const int MAXN = 2000001;	
bool w[MAXN];
bool cycle[MAXN];
ll a[MAXN];
ll b[MAXN];
int nx[MAXN];
ll l[MAXN];
int q[MAXN], qb = 0, qe = 0;
ll val[MAXN];
vector <pair <int, ll> > e[MAXN];
vector <int> cyc;
ll ans =0;

int bv;
ll bd;
void dfspath(int v, int p, ll d)
{
	w[v] = true;
	if (v == p)
	{
		bv = v, bd = 0;
	}
	if (d > bd) bv = v, bd = d;
	for (int i = 0; i < e[v].size(); i++)
	{ 
		int u = e[v][i].first;
		if (!cycle[u] &&  (u != p))
		{
			dfspath(u, v, d + e[v][i].second);
		}
	}
}

int cs;

void ad(int id, ll vl)
{
	while ((qe > qb) && (val[qe - 1] < vl)) qe--;
	q[qe] = id;
	val[qe] = vl;
	qe++;
}

ll ansc = 0;
	
void calc()
{
	qb = qe = 0;
	for (int i = 0; i < cs; i++) a[i + cs] = a[i], b[i + cs] = b[i];
	ll mdf = 0;
	ad(0, a[0]);
	for (int i = 1; i < cs; i++)
	{
		mdf += b[i - 1];
		if (i != 0)
		ad(i, a[i] - mdf);
	}
	for (int i = cs; i < 2 * cs; i++)
	{
		if (q[qb] == i - cs) qb++;
		mdf += b[i - 1];
		ansc = max(ansc, val[qb] + mdf + a[i]);
		ad(i, a[i] - mdf);
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		w[i] = cycle[i]  = false;
		int tl;
		scanf("%d%d", &nx[i], &tl);
		l[i] = tl;
		e[i].push_back(make_pair(nx[i], l[i]));
		e[nx[i]].push_back(make_pair(i, l[i]));
	}
	for (int st = 1; st <= n; st++)
	{
		if (w[st]) continue;
		ansc = 0;
		int cur = st;
		while (!w[cur])
		{
			w[cur] = true;
			cur = nx[cur];
		}
		cyc.clear();
		int nc = cur;
		do
		{
			cyc.push_back(nc);
			cycle[nc] = true;
			nc = nx[nc];
		}
		while (nc != cur);
		cs = cyc.size();
		for (int i = 0; i < cs; i++)
		{
			cycle[cyc[i]] = false;
			dfspath(cyc[i], cyc[i], 0);
			a[i] = bd;
			dfspath(bv, bv, 0);
			ansc = max(ansc, bd);
			cycle[cyc[i]] = true;
		}
		for (int i = 0; i < cs; i++) b[i] = l[cyc[i]];
		calc();
		for (int i = 1; i < cs - i; i++) swap(a[i], a[cs - i]);
		for (int i = 0; i < cs; i++) b[i] = l[cyc[cs - 1 - i]];
		calc();
		ans += ansc;
		if (n > 7) return 0;
	}
	cout << ans << endl;
	return 0;
}
