#include <bits/stdc++.h>

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 20179;
const int K = 2015;
const int D = 1000;

int n;
int x[N], y[N];
int da[N][K], db[N][K];

int main()
{
    ios::sync_with_stdio(false);

    cin >> n;
    x[0] = y[0] = D;
    for (int i = 1; i <= n; ++i)
    {
        cin >> x[i] >> y[i];
        x[i] += D;
        y[i] += D;
    }
    for (int i = 0; i < K; ++i)
    { 
        da[0][i] = abs(D-i);
        db[0][i] = abs(D-i);
    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < K; ++j)
        {
            da[i+1][j] = min(da[i][j]+abs(x[i]-x[i+1]), db[i][x[i+1]]+abs(y[i]-j));
            db[i+1][j] = min(db[i][j]+abs(y[i]-y[i+1]), da[i][y[i+1]]+abs(x[i]-j));
        }

    int ans = IINF;
    for (int i = 0; i < K; ++i)
        ans = min(ans, min(da[n][i], db[n][i]));
    cout << ans << "\n";

    return 0;
}
