#include <cstring>
#include <algorithm>
#include <vector>
#include "grader.h"

int valid(int n, int inputSeq[])
{
	static bool was[300000];
	memset(was, 0, sizeof(was));
	int pos1 = -1;
	for (int i = 0; i < n; ++i)
	{
		if (was[inputSeq[i]])
			return 0;
		was[inputSeq[i]] = true;
		if (inputSeq[i] <= n)
		{
			int npos1 = (n + i - inputSeq[i] + 1) % n;
			if (pos1 == -1)
				pos1 = npos1;
			else if (pos1 != npos1)
				return 0;
		}
	}
	return 1;
}

int replacement(int n, int gondolaSeq[], int replacementSeq[])
{
	int pos1 = 0;
	for (int i = 0; i < n; ++i)
		if (gondolaSeq[i] <= n)
			pos1 = (n + i - gondolaSeq[i] + 1) % n;
	static int ind[100500];
	for (int i = 0; i < n; ++i)
		ind[i] = i;
	std::sort(ind, ind + n, [gondolaSeq](int a, int b){return gondolaSeq[a] < gondolaSeq[b];});
	int curr = n + 1;
	int a = 0;
	for (int i = 0; i < n; ++i)
	{
		int x = gondolaSeq[ind[i]];
		if (x <= n)
			continue;
		int was = (n + ind[i] - pos1) % n + 1;
		replacementSeq[a++] = was;
		while (curr < x)
		{
			replacementSeq[a++] = curr;
			++curr;
		}
		++curr;
	}
	return a;
}

long long pw(long long a, long long b)
{
	int aa = a, ans = 1;
	while (b != 0)
	{
		if (b & 1)
			(ans *= aa) %= 1000000009;
		(aa *= aa) %= 1000000009;
		b >>= 1;
	}
	return ans;
}