#include <iostream>
#include <cstdio>
#include <vector>

#define F 0
#define M 1
#define B 2
#define N 3;

using namespace std;

const int MAXN = 100001;
int f1[16][16], f2[16][16];
bool a[4];

int main()
{
	int n;
	cin >> n;
	for (int j = 0; j < 16; j++)
	{
		for (int k = 0; k < 16; k++)
		{
			f1[j][k] = -MAXN * 5;
		}
	}
	f1[15][15] = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < 16; j++)
		{
			for (int k = 0; k < 16; k++)
			{
				f2[j][k] = -MAXN * 5;
			}
		}
		char c;
		cin >> c;
		int fd;
		if (c == 'F') fd = F;
		else if (c == 'B') fd = B;
		else fd = M;
		for (int j = 0; j < 16; j++)
		{
			for (int k = 0; k < 16; k++)
			{
				//Give to first
				int fs, sc, cnt;
				for (int l = 0; l < 3; l++) a[l] = false;
				fs = j / 4, sc = j % 4;
				a[fd] = a[sc] = a[fs] = true;
				cnt = 0;
				if (a[0]) cnt++; if (a[1]) cnt++; if (a[2]) cnt++;
				f2[sc * 4 + fd][k] = max(f2[sc * 4 + fd][k], f1[j][k] + cnt);

				//Give to second
				for (int l = 0; l < 3; l++) a[l] = false;
				fs = k / 4, sc = k % 4;
				a[fd] = a[sc] = a[fs] = true;
				cnt = 0;
				if (a[0]) cnt++; if (a[1]) cnt++; if (a[2]) cnt++;
				f2[j][sc * 4 + fd] = max(f2[j][sc * 4 + fd], f1[j][k] + cnt);
			}
		}
		for (int j = 0; j < 16; j++)
		{
			for (int k = 0; k < 16; k++)
			{
				f1[j][k] = f2[j][k];
			}
		}
	}
	int mx = 0;
	for (int i = 0; i < 16; i++)
	{
		for (int j = 0; j < 16; j++)
		{
			mx = max(mx, f1[i][j]);
		}
	}
	cout << mx << endl;
	return 0;
}