#include "grader.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <set>
#include <vector>
#include <map>
#include <cstdlib>
#include <string>
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;

const int nmax = 1000 * 1000;
const int inf = 1000 * 1000;

struct node {
    int k, k1;
    map<ll, int> a;
    node() {
        k = 0;
        k1 = 0;
        a.clear();
    }
    node(int K, const map<ll, int> &A) {
        k = K;
        a = A;
    }
};

int answer = inf, n, k;
bool used[nmax];
vector<pair<ll, int> > a[nmax];

node dfs(int v) {
    used[v] = true;
    node now;
    now.a[0] = 0;
    for (int i = 0; i < (int)a[v].size(); i++) {
        if (!used[a[v][i].first]) {
            node qq = dfs(a[v][i].first);
            qq.k1++;
            qq.k += a[v][i].second;
            if (qq.a.count(k - qq.k)) {
                answer = min(answer, qq.a[k - qq.k] + qq.k1);
            }
            if (now.a.size() < qq.a.size()) {
                swap(now.a, qq.a);
                swap(now.k, qq.k);
                swap(now.k1, qq.k1);
            }
            for (map<ll, int>::iterator it = qq.a.begin(); it != qq.a.end(); it++) {
                if (now.a.count(it->first + qq.k - now.k)) {
                    answer = min(answer, now.a[it->first + qq.k - now.k] + it->second + now.k1 + qq.k1);
                }
            }
            for (map<ll, int>::iterator it = qq.a.begin(); it != qq.a.end(); it++) {
                if (now.a.count(it->first + qq.k - now.k) == 0) {
                    now.a[it->first + qq.k - now.k] = inf;
                }
                now.a[it->first + qq.k - now.k] = min(now.a[it->first + qq.k - now.k], it->second + qq.k1 - now.k1);
            }
        }
    }
    return now;
}

int best_path(int N, int K, int h[][2], int l[]) {
    n = N;
    k = K;
    for (int i = 0; i < n - 1; i++) {
        a[h[i][0]].pb({h[i][1], l[i]});
        a[h[i][1]].pb({h[i][0], l[i]});
    }
    node now = dfs(0);
    if (answer == inf) {
        answer = -1;
    }
    return answer;
}
