#include "grader.h"
#include "grader.h"
#include "grader.h"
#include <vector>

using namespace std;

const int MAXN = 1000;
const int MAXH = 36;
vector <int> e[MAXN];
int p[MAXN];
int d[MAXN];
int q[MAXN], qe;
void dfs(int v)
{
    for (int i = 0; i < e[v].size(); i++)
    {
        if (p[e[v][i]] != -1) continue;
        p[e[v][i]] = v;
        dfs(e[v][i]);
    }
}

void encode(int nv, int nh, int ne, int *v1, int *v2){
    p[0] = 0;
    for (int i = 1; i < nv; i++) p[i] = -1;
    for (int i = 0; i < ne; i++)
    {
        e[v1[i]].push_back(v2[i]);
        e[v2[i]].push_back(v1[i]);
    }
    dfs(0);
    for (int i = 1; i < nv; i++)
    {
        for (int j = 9; j >= 0; j--) encode_bit((p[i] % (1 << (j + 1))) / (1 << j));
    }
    for (int i = 0; i < nh; i++)
    {
        for (int j = 0; j < nv; j++) d[j] = MAXN * 2;
        qe = 1;
        q[0] = i;
        d[i] = 0;
        for (int j = 0; j < nv; j++)
        {
            int v = q[j];
            for (int l = 0; l < e[v].size(); l++)
            {
                if (d[e[v][l]] == MAXN * 2)
                {
                    d[e[v][l]] = d[v] + 1;
                    q[qe++] = e[v][l];
                }
            }
        }
        for (int j = nv; j < MAXN; j++)
        {
            p[j] = 0;
            d[j] = d[0];
        }
        for (int j = 0; j < MAXN / 3; j++)
        {
            int cur = (d[j * 3 + 1] - d[p[j * 3 + 1]] + 1) * 9 + (d[j * 3 + 2] - d[p[j * 3 + 2]] + 1) * 3 + (d[j * 3 + 3] - d[p[j * 3 + 3]] + 1);
            for (int l = 4; l >= 0; l--)
            {
                encode_bit((cur % (1 << (l + 1))) / (1 << l));
            }
        }
    }
}

int p2[MAXN];
int a[MAXN];
vector <int> e2[MAXN];
vector <int> tin;
int d2[MAXN];

void dfs2(int v)
{
    tin.push_back(v);
    for (int i = 0; i < e2[v].size(); i++)
    {
         dfs(e2[v][i]);
    }
}

void decode(int nv, int nh) {
    for (int i = 1; i < nv; i++)
    {
        p2[i] = 0;
        for (int j = 0; j < 10; j++)
        {
            p2[i] = p2[i] * 2 + decode_bit();
        }
        e2[p2[i]].push_back(i);
    }
    dfs2(0);
    for (int i = 0; i < nh; i++)
    {
        a[0] = 0;
        for (int j = 0; j < MAXN / 3; j++)
        {
            int cur = 0;
            for (int l = 0; l < 5; l++)
            {
                cur = cur * 2 + decode_bit();
            }
            a[j * 3 + 1] = cur / 9 - 1;
            a[j * 3 + 2] = (cur % 9) / 3 - 1;
            a[j * 3 + 3] = cur % 3 - 1;
        }
        d2[0] = 0;
        int cc = i;
        while (cc != 0) 
        {
            d2[0] -= a[cc];
            cc = p[cc];
        }
        for (int j = 0; j < nv; j++)
        {
            d2[j] = d2[p2[j]] + a[j];
            hops(i, j, d2[j]);
        }
    }
}
