#include "grader.h"
#include <vector>
#include <cmath>
	
using namespace std;

const int MAXN = 100001;

vector <int> e[MAXN];
int d[MAXN];
int q[MAXN], qe;

int DistanceSum(int N, int *X, int *Y) {
	int n = N;
	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			if (abs(X[i] - X[j]) + abs(Y[i] - Y[j]) == 1) e[i].push_back(j), e[j].push_back(i);
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++) d[j] = n + 1;
		qe = 1, q[0] = i;
		d[i] = 0;
		for (int j = 0; j < n; j++)
		{
			int v = q[j];
			ans += d[v];
			for (int l = 0; l < e[v].size(); l++)
			{
				int u = e[v][l];
				if (d[u] == n + 1)
				{
					d[u] = d[v] + 1;
					q[qe++] = u;
					q[qe] = 1;
				}
			}
		}
	}
	return ans / 2;
}
