#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

const int MAXN = 200001;
long long a[MAXN];
long long s[MAXN];

int besthub(int n, int l, int tt[], long long b)
{
	s[0] = 0;
	for (int i = 1; i <= n; i++) 
	{
		a[i] = tt[i - 1];
	}
	sort(a + 1, a + n);
	for (int i = 1; i <= n; i++) s[i] = s[i - 1] + a[i];
	int lg = 1, rg = n;
	while (lg < rg)
	{
		int md = (lg + rg + 1) / 2;
		int lt = (md - 1) / 2, rt = (md - 1) - lt;
		bool ok = false;
		for (int i = lt + 1; i <= n - rt; i++)
		{
			long long b1 = (a[i] * lt) - (s[i - 1] - s[i - lt - 1]);
			long long b2 = (s[i + rt] - s[i]) - a[i] * rt;
			if (b1 + b2 <= b) ok = true;
		}
		if (ok) lg = md;
		else rg = md - 1;
	}
	return lg;
}
