#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#define y1 y11
using namespace std;

const int MAXN = 70001;
int x1[MAXN], y1[MAXN], x2[MAXN], y2[MAXN], c[MAXN];

struct sob
{
	int x, md, l, r;
};

bool cmp(sob p1, sob p2)
{
	return make_pair(p1.x, -p1.md) < make_pair(p2.x, -p2.md);
}

sob a[MAXN];
int ac = 0;
const int MAXM = 4000007;
int rmq[MAXN], val[MAXN];
int z1, z2, vl;

void modify_rmq(int v, int l, int r)
{
	if ((l > z2) || (z1 > r)) return;
	if ((z1 <= l) && (r <= z2))
	{
		rmq[v] += vl;
		val[v] += vl;
	}
	else
	{
		int md = (l + r) / 2;
		modify_rmq(v * 2 + 1, l, md);
		modify_rmq(v * 2 + 2, md + 1, r);
		rmq[v] = min(rmq[v * 2 + 1], rmq[v * 2 + 2]) + val[v];
	}
}



int main()
{
	int n, m, b, p;
	cin >> n >> m >> b >> p;
	for (int i = 0; i < p; i++)
	{
		cin >> x1[i] >> y1[i] >> x2[i] >> y2[i] >> c[i];
		x1[i]--, y1[i]--;
	}
	int lg = 0, rg = min(n, m);
	while (lg < rg)
	{
		int md = (lg + rg + 1) / 2;
		bool ok = false;
		ac = 0;	
		for (int i = 0; i < MAXN; i++) rmq[i] = val[i] = 0;			
		for (int i = 0; i < p; i++)
		{
			a[ac].x = x1[i] - md + 1, a[ac].md = c[i], a[ac].l = y1[i] - md + 1, a[ac].r= y2[i] - 1; ac++;
			a[ac].x = x2[i], a[ac].md = -c[i], a[ac].l = y1[i] - md + 1, a[ac].r= y2[i] - 1; ac++;
		}
		a[ac].x = 0, a[ac].md = 0, a[ac].l = 0, a[ac].r= 0; ac++;
		a[ac].x = n - md, a[ac].md = 0, a[ac].l = 0, a[ac].r= 0; ac++;
		sort(a, a + ac, cmp);
		for (int i = 0; i < ac; i++)
		{
			z1 = a[i].l			, z2 = a[i].r, vl = a[i].md;
			modify_rmq(0, 0, m - md);
			if ((a[i].x >= 0) && (a[i].x <= n - md) && ((i == ac - 1) || (a[i].x != a[i + 1].x)) && (rmq[0] <= b)) ok = true;
		}
		if (ok) lg = md;
		else rg = md - 1;
	}
	cout << lg << endl;
	return 0;
}