#include "grader.h"
#include <set>
#include <algorithm>
#include <iostream>

using namespace std;

set <pair <int, int> > st;
const int MAXN = 200001;
int nx[MAXN];
int p[MAXN];
bool ac[MAXN];
bool cur[MAXN];

void ComputeAdvice(int *C, int N, int K, int M) {
	for (int i = 0; i < N; i++) p[i] = -1, cur[i] = false;
	for (int i = 0; i < K; i++) p[i] = i;
	for (int i = 0; i < N; i++)
	{
		int x = C[i];
		if (p[x] != -1)
		{
			nx[p[x]] = i + K;
			p[x] = i + K;
		}
		else p[x] = i + K;
	}
	for (int i = 0; i < N; i++)
	{
		if (p[i] != -1) nx[p[i]] = N + K;
	}
	for (int i = 0; i < N + K; i++) ac[i] = true;
	for (int i = 0; i < K; i++)
	{
		st.insert(make_pair(-nx[i], i));
		cur[i] = true;
	}
	for (int i = 0; i < N; i++)
	{
		int x = C[i];
		if (cur[x])
		{
			st.erase(*st.lower_bound(make_pair(-i - K, -1)));
		}
		else
		{
			int v = st.begin()->second;
			cur[x] = true;
			if (v < K)
			{
				ac[v] = false;
				cur[v] = false;
			}
			else
			{
				ac[v] = false;
				cur[C[v - K]] = false;
			}
			st.erase(*st.begin());
		}
		st.insert(make_pair(-nx[i + K], i + K));
	}
	for (int i = 0; i < N + K; i++)
	{
		if (ac[i]) WriteAdvice(1);
		else WriteAdvice(0);
	}
}

set <int> mb;
bool f[MAXN];

void Assist(unsigned char *A, int N, int K, int R) {

  int i;
  for (int i = 0; i < N; i++) f[i] = false;
  for (int i = 0; i < K; i++)
  {
	  if (A[i] == 0) mb.insert(i);
	  f[i] = true;
  }
  for (int i = 0; i < N; i++) 
  {
	  int g = GetRequest();
	  if (!f[g])
	  {
		  PutBack(*mb.begin());
		  mb.erase(*mb.begin());
	  }
	  if (A[i + K] == 0) mb.insert(g);
  }
  int x = N;
}
