#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 20001;
int fx[MAXN], fy[MAXN];
int x[MAXN], y[MAXN];
int nx[MAXN], ny[MAXN];
const int INF = 1000 * 1000 * 1000;

int main()
{
	int n;
	scanf("%d", &n);
	x[0] = 0, y[0] = 0;
	fx[0] = fy[0] = 0;
	for (int i = 1; i <= n; i++)
	{
		scanf("%d%d", &x[i], &y[i]);
		fx[i] = fy[i] = INF;
		for (int j = 0; j + 1 < i; j++)
		{ 
			nx[j] = fx[j] + abs(x[i] - x[i - 1]);
			ny[j] = fy[j] + abs(y[i] - y[i - 1]);
		}
		int rx = INF, ry = INF;
		for (int j = 0; j < i; j++)
		{
			rx = min(rx, fy[j] + abs(x[i] - x[j]));
			ry = min(ry, fx[j] + abs(y[i] - y[j]));
		}
		for (int j = 0; j + 1 < i; j++) fx[j] = nx[j], fy[j] = ny[j];
		fx[i - 1] = rx, fy[i - 1] = ry;
	}
	int rs = INF;
	for (int i = 0; i <= n; i++) rs = min(rs, fx[i]), rs = min(rs, fy[i]);
	cout << rs << endl;
	return 0;
}