#include "grader.h"
#include <algorithm>
#include <set>

using namespace std;

multiset <long long> st;
long long cr[4001];
long long attraction[4001];

long long int findMaxAttraction(int n, int start, int d, int attract[]) {
	for (int i = 0; i < n; i++) attraction[i] = attract[i];
	if (start != 0)
	{
		long long ans = 0;
		for (int i = 0; i <= start; i++)
		{
			st.clear();
			long long cur = 0;
			for (int j = i; j <= start; j++)
			{
				cur += attraction[j];
				st.insert(attraction[j]);
			}
			while (!st.empty() && ((int)st.size() > (d - (start - i))))
			{
				cur -= *st.begin();
				st.erase(st.begin());
			}
			ans = max(ans, cur);
			for (int j = start + 1; j < n; j++)
			{
				cur += attraction[j];
				st.insert(attraction[j]);
				int cn = d - (j - i) - min(start - i, j - start);
				while (!st.empty() && ((int)st.size() > cn))
				{
					cur -= *st.begin();
					st.erase(*st.begin());
				}
				ans = max(ans, cur);
			}
		}
		return ans;
	}
	else
	{
		long long ans = 0;
		long long ca = 0;
		for (int i = 0; i < n; i++)
		{
			ca += attraction[i];
			st.insert(attraction[i]);
			int c = st.size() - (d - i);
			for (int j = 0; j < c; j++)
			{
				ca -= *st.begin();
				st.erase(st.begin());
			}
			ans = max(ca, ans);
		}
		return ans;
	}
}
