#include "grader.h"
#include <vector>

using namespace std;

vector<int> edge[1000000];
int maxm[1000000];
int p[1000000];
bool used[1000000];
int sml;

int dfs(int u){
    used[u] = true;
    int sm = 0;
    for (int i = 0; i < edge[u].size(); i++){
        if (!used[edge[u][i]]){
            int k = dfs(edge[u][i]);
            maxm[u] = max(maxm[u], k);
            maxm[edge[u][i]] = max(maxm[edge[u][i]], sml - k);
            sm += k;
        }
    }
    return sm + p[u];
}

int LocateCentre(int N, int pp[], int S[], int D[]) {
    int n = N;
    sml = 0;
    for (int i = 0; i < n - 1; i++){
        edge[S[i]].push_back(D[i]);
        edge[D[i]].push_back(S[i]);
        p[i] = pp[i];
        sml += p[i];
    }
    p[n - 1] = pp[n - 1];
    sml += p[n - 1];
    dfs(0);
    int mn = 2000000001;
    int mini = 0;
    for (int i = 0; i < n; i++){
        if (mn > maxm[i]){
            mn = maxm[i];
            mini = i;
        }
    }
    return mini;
}
