#include <iostream>
#include <cstring>

const int N = 50;
const int INF = 100500500;

int n, m, a[N][N], d[N][N][N][N], sum[N][N][N][N];

int ubitVsehChelovekov(int x1, int y1, int x2, int y2)
{
    if (d[x1][y1][x2][y2] != -1)
        return d[x1][y1][x2][y2];
    if (x1 == x2 && y1 == y2)
    {
        sum[x1][y1][x2][y2] = a[x1][y1];
        return d[x1][y1][x2][y2] = 0;
    }
    int ans = INF;
    for (int i = x1; i < x2; ++i)
        ans = std::min(ans, ubitVsehChelovekov(x1, y1, i, y2) + ubitVsehChelovekov(i + 1, y1, x2, y2));
    for (int i = y1; i < y2; ++i)
        ans = std::min(ans, ubitVsehChelovekov(x1, y1, x2, i) + ubitVsehChelovekov(x1, i + 1, x2, y2));
    if (x1 == x2)
        sum[x1][y1][x2][y2] = sum[x1][y1][x2][y2 - 1] + a[x2][y2];
    else
        sum[x1][y1][x2][y2] = sum[x1][y1][x2 - 1][y2] + sum[x2][y1][x2][y2];
    return d[x1][y1][x2][y2] = ans + sum[x1][y1][x2][y2];
}

int main()
{
    std::cin >> n >> m;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            std::cin >> a[i][j];
    memset(d, -1, sizeof(d));
    std::cout << ubitVsehChelovekov(0, 0, n - 1, m - 1);
    return 0;
}
