
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <queue>
#include <stack>
#include <stdlib.h>
#include <cassert>
#include <bitset>
#include <ctime>
#define mp make_pair
#define pb push_back
#define y1 y1_jkd
#include "grader.h"

using namespace std;

typedef long long ll;
typedef long double ld;

const int nmax = 2000 * 1000;

vector<ll> a[nmax];
ll sz[nmax], p[nmax];
bool used[nmax];

void dfs(int v)
{
	used[v] = true;
	sz[v] = p[v];
	for (int i = 0; i < a[v].size(); i++)
		if (!used[a[v][i]])
		{
			dfs(a[v][i]);
			sz[v] += sz[a[v][i]];
		}
}

int getans(int v)
{
	ll ans = 0;
	for (int i = 0; i < a[v].size(); i++)
		ans = max(ans, sz[a[v][i]]);
	return ans;
}

ll ans, answ;

void dfsa(int v)
{
	used[v] = true;
	ll qq = getans(v);
	if (qq < ans)
	{
		ans = qq;
		answ = v;
	}
	for (int i = 0; i < a[v].size(); i++)
	{
		if (!used[a[v][i]])
		{
			sz[v] -= sz[a[v][i]];
			sz[a[v][i]] += sz[v];
			dfsa(a[v][i]);
			sz[a[v][i]] -= sz[v];
			sz[v] += sz[a[v][i]];
		}
	}
}

int LocateCentre(int n, int pp[], int S[], int D[])
{
	for (int i = 0; i < n; i++)
		p[i] = pp[i];
	for (int i = 0; i < n - 1; i++)
	{
		a[S[i]].pb(D[i]);
		a[D[i]].pb(S[i]);
	}
	for (int i = 0; i < n; i++)
		used[i] = false;
	dfs(0);
	for (int i = 0; i < n; i++)
		used[i] = false;
	answ = 0;
	ans = getans(0);
	dfsa(0);
	return answ;
}
