#include "grader.h"
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1001;
vector <pair <int, int> > e[MAXN];

void count_routes(int N, int M, int P, int R[][2], int Q, int G[])
{
	int k = G[0];
	for (int i = 0; i < M; i++)
	{
		e[R[i][0]].push_back(make_pair(R[i][1], i));
		e[R[i][1]].push_back(make_pair(R[i][0], i));
	}
	if (e[P].size() == 0) answer(1);
	int res = 0;
	for (int i = 0; i < N; i++)
	{
		int cur = i, pr = M;
		if (e[i].size() == 0) continue;
		for (int j = 0; j < k; j++)
		{
			if ((e[cur].size() > 1) && (pr == e[cur][0].second)) pr = e[cur][1].second, cur = e[cur][1].first;
			else pr = e[cur][0].second, cur = e[cur][0].first;
		}
		if (cur == P) res++;
	}
	answer(res);
}

