#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
const int MAXN = 10000;
vector < pair <int, int> > ed;
vector <pair <int, ll> > e[MAXN];
bool w[MAXN], w2[MAXN];	
int da1, did1, da2, did2;

vector <int> cur;

void dfs_find(int v)
{
	w[v] = true;
	cur.push_back(v);
	for (int i = 0; i < e[v].size(); i++)
	{
		if (!w[e[v][i].first]) 
		{
			dfs_find(e[v][i].first);
		}
	}
}

bool gd(int a, int id)
{
	return ((a != da1) || (id != did1)) && ((a != da2) || (id != did2));
}

void dfs_chck(int v)
{
	w2[v] = true;
	for (int i = 0; i < e[v].size(); i++)
	{
		if ((gd(v, i)) && (!w2[e[v][i].first]))
			dfs_chck(e[v][i].first);;
	}
}

ll md;
int mv;

void dfs_dst(int v, int p, ll d)
{
	if (d > md) md = d, mv = v;
	for (int i = 0; i < e[v].size(); i++)
	{
		if (gd(v, i) && (e[v][i].first != p))
			dfs_dst(e[v][i].first, v, d + e[v][i].second);
	}
}


int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		int ds;
		ll vl;
		cin >> ds >> vl;
		e[ds].push_back(make_pair(i, vl));
		e[i].push_back(make_pair(ds, vl));
	}
	ll sum = 0;
	for (int i = 1; i <= n; i++)
	{
		if (w[i]) continue;
		ed.clear();
		cur.clear();
		dfs_find(i);
		ll ans = 0;
		for (int sai = 0; sai < cur.size(); sai++)
		{
			int sa = cur[sai];
			for (int eid = 0; eid < e[sa].size(); eid++)
			{
				da1 = sa, did1 = eid;
				int v2 = e[sa][eid].first;
				for (int e2 = 0; e2 < e[v2].size(); e2++)
				{
					if ((e[v2][e2].first == sa) && (e[v2][e2].second == e[sa][eid].second))
					{
						da2 = v2, did2 = e2;
						break;
					}
				}
				for (int ii = 0; ii < cur.size(); ii++) w2[cur[ii]] = false;
				dfs_chck(da1);
				if (!w2[da2]) continue;
				md = -1;
				dfs_dst(i, i, 0);
				md = -1;
				dfs_dst(mv, mv, 0);
				ans = max(ans, md);
			}
		}
		sum += ans;
	}
	cout << sum << endl;
	return 0;
}