#include "grader.h"
#include <algorithm>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1000 * 1000 + 1;
pair <int, int> ord[MAXN];
int tt[MAXN];


void findLocation(int N, int first, int location[], int stype[])
{
	for (int i = 0; i < MAXN; i++) tt[i] = 0;
	for (int i = 1; i < N; i++)
	{
		ord[i] = make_pair(getDistance(0, i), i);
	}
	sort(ord + 1, ord + N);
	int ri = ord[1].second, rd = first + ord[1].first;
	int li = 0, ld = first;
	tt[ld] = 1, tt[rd] = 2;
	int d1 = ord[1].first;
	int i1 = ord[1].second;
	location[0] = first, stype[0] = 1;
	location[i1] = first + d1, stype[i1] = 2;
	tt[location[0]] = 1;
	tt[location[i1]] = 2;
	for (int i = 2; i < N; i++)
	{
		int id = ord[i].second;;
		int k1 = getDistance(i1, id);		
		int k0 = ord[i].first;
		if (k1 < d1)
		{
			location[id] = location[i1] - k1;
			stype[id] = 1;
		} 
		else if (k0 != d1 + k1)
		{
			int rk = getDistance(id, ri);
			int v =	((rd - first) + rk) - k0;
			v = rd - (v / 2);
			if (tt[v] == 2)
			{
				location[id] = rd - rk;
				stype[id] = 1;
			}
			else
			{
				location[id] = first + k0;
				stype[id] = 2;
				ri = id;
				rd = location[id];
			}
		}
		else
		{ 
			int lk = getDistance(id, li);
			int v =	((first + d1 - ld) + lk) - k1;
			v = ld + (v / 2);
			if (tt[v] == 1)
			{
				location[id] = ld + lk;
				stype[id] = 2;
			}
			else
			{
				location[id] = first + d1 - k1;
				stype[id] = 1;
				li = id;
				ld = location[id];
			}
		}
		tt[location[id]] = stype[id];
	}
}
