#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 30000;
const int AD = 32;

vector <string> a;
vector <char> ans;

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	a.resize(n);
	int mind = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		if (a[i].length() > a[mind].length()) mind = i;
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < a[i].length(); j++)
		{
			if (a[i][j] != a[mind][j])
			{
				a[i][j] -= AD;
			}
		}
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < a[0].length(); i++)
	{
		ans.push_back(a[0][i]);
	}
	ans.push_back('#');
	for (int j = 1; j < n; j++)
	{
		int l = 0;
		while (l < min(a[j].length(), a[j - 1].length()))
		{
			if (a[j][l] == a[j - 1][l]) l++;
			else break;
		}
		for (int i = l; i < a[j - 1].length(); i++)
		{
			ans.push_back('-');
		}
		for (int i = l; i < a[j].length(); i++)
		{
			ans.push_back(a[j][i]);
		}
		ans.push_back('#');
	}
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++)
	{
		if ((ans[i] >= 'A') && (ans[i] <= 'Z')) ans[i] += AD;
		else if (ans[i] == '#') ans[i] = 'P';
		cout << ans[i] << endl;
	}
	return 0;
}