#include "grader.h"
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;

vector<ll> x;
ll maxc;
int n;

bool check(int k) {
    ll dist = 0;
    for (int i = 0; i < k; i++) {
        dist += abs(x[i] - x[k / 2]);
    }
    if (dist <= maxc) {
        return true;
    }
    int m1 = k / 2 + 1, r1 = k;
    for (int l1 = 1; l1 < n - k; l1++, m1++, r1++) {
        ll zz = x[l1] - x[l1 - 1];
        dist += zz * (m1 - l1 + 1);
        dist -= x[m1] - x[l1 - 1];
        dist -= zz * (r1 - m1 - 1);
        dist += x[r1] - x[m1];
        if (dist <= maxc) {
            return true;
        }
    }
    return false;
}

int besthub(int N, int L, int X[], long long B){
    n = N;
    maxc = B;
    for (int i = 0; i < n; i++) {
        x.pb(X[i]);
    }
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int k = (l + r) / 2;
        if (check(k)) {
            l = k;   
        } else {
            r = k;
        }
    }
    return l;
}
