#include <iostream>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <queue>
#include "grader.h"

typedef long long lint;
const int N = 100500;

std::ostream & operator << (std::ostream & out, std::priority_queue < int , std::vector < int > , std::greater<int> > q)
{
	while (!q.empty())
	{
		out << q.top() << " ";
		q.pop();
	}
	return out;
}

lint findMaxAttraction(int n, int start, int d, int att[])
{
	lint ans = 0, sgprq = 0;
	std::priority_queue < int , std::vector < int > , std::greater<int> > gprq;
	for (int l = start; l >= 0; --l)
	{
		int od = d - (start - l) * 3;
		if (od <= 0)
			break;
		gprq.push(att[l]);
		sgprq += att[l];
		if (start + (start - l) < n)
		{
			if (l != start)
			{
				gprq.push(att[start + (start - l)]);
				sgprq += att[start + (start - l)];
			}
		} else
			break;
		while ((int)gprq.size() > od)
		{
			sgprq -= gprq.top();
			gprq.pop();
		}
		std::priority_queue < int , std::vector < int > , std::greater<int> > prq = gprq;
		lint sprq = sgprq;
		for (int r = start + (start - l); r < n && od > 0; ++r)
		{
			if (r != start + (start - l))
			{
				prq.push(att[r]);
				sprq += att[r];
				while ((int)prq.size() > od)
				{
					sprq -= prq.top();
					prq.pop();
				}
			}
			ans = std::max(ans, sprq);
			--od;
		}
	}
	sgprq = 0;
	while (!gprq.empty())
		gprq.pop();
	std::reverse(att, att + n);
	start = n - 1 - start;
	for (int l = start; l >= 0; --l)
	{
		int od = d - (start - l) * 3;
		if (od <= 0)
			break;
		gprq.push(att[l]);
		sgprq += att[l];
		if (start + (start - l) < n)
		{
			if (l != start)
			{
				gprq.push(att[start + (start - l)]);
				sgprq += att[start + (start - l)];
			}
		} else
			break;
		while ((int)gprq.size() > od)
		{
			sgprq -= gprq.top();
			gprq.pop();
		}
		std::priority_queue < int , std::vector < int > , std::greater<int> > prq = gprq;
		lint sprq = sgprq;
		for (int r = start + (start - l); r < n && od > 0; ++r)
		{
			if (r != start + (start - l))
			{
				prq.push(att[r]);
				sprq += att[r];
				while ((int)prq.size() > od)
				{
					sprq -= prq.top();
					prq.pop();
				}
			}
			ans = std::max(ans, sprq);
			--od;
		}
	}
	return ans;
}