#include <iostream>
#include <cstdio>

using namespace std;

const long long INF = 1e18 + 7;
long long a[51][51];
long long ans[51][51][51][51];
long long sum[51][51][51][51];

int main()
{
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // DEBUG
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            scanf("%d", &a[i][j]);
            ans[i][i][j][j] = 0;
        }
    }
    for (int x1 = 0; x1 < n; x1++){
        for (int y1 = 0; y1 < m; y1++){
            for (int x2 = x1; x2 < m; x2++){
                for (int y2 = y1; y2 < m; y2++){
                    if (x1 == x2 && y1 == y2){
                        sum[x1][x2][y1][y2] = a[x1][y1];
                    }
                    else if(x1 == x2){
                        sum[x1][x2][y1][y2] = sum[x1][x2][y1][y2 - 1] + a[x2][y2];
                    }
                    else if(y1 == y2){
                        sum[x1][x2][y1][y2] = sum[x1][x2 - 1][y1][y2] + a[x2][y2];
                    }
                    else{
                        sum[x1][x2][y1][y2] = sum[x1][x2 - 1][y1][y2] + sum[x1][x2][y1][y2 - 1] - sum[x1][x2 - 1][y1][y2 - 1] + a[x2][y2];
                    }
                }
            }
        }
    }
    for (int lx = 0; lx < n; lx++){
        for (int ly = 0; ly < m; ly++){
            for (int x = 0; x < n - lx; x++){
                for (int y = 0; y < m - ly; y++){
                    if (lx != 0 || ly != 0){
                        ans[x][x + lx][y][y + ly] = INF;
                        for (int k = x; k < x + lx; k++){
                            ans[x][x + lx][y][y + ly] = min(ans[x][x + lx][y][y + ly], ans[x][k][y][y + ly] + ans[k + 1][x + lx][y][y + ly]);
                        }
                        for (int k = y; k < y + ly; k++){
                            ans[x][x + lx][y][y + ly] = min(ans[x][x + lx][y][y + ly], ans[x][x + lx][y][k] + ans[x][x + lx][k + 1][y + ly]);
                        }
                        ans[x][x + lx][y][y + ly] += sum[x][x + lx][y][y + ly];
                    }
                }
            }
        }
    }
    cout << ans[0][n - 1][0][m - 1];
    return 0;
}
