#include <iostream>
#include <cstdio>
#include <algorithm>
#include <map>

using namespace std;

int n[2001];
int r[2001];
map<pair<int, int>, int> ok;

bool gok(int q, int m){
    if (q < 0) return false;
    if (m == 0){
        return q == 0;
    }
    int k = ok[make_pair(q, m)];
    k--;
    if (k >= 0) return k;
    k = (gok(q, m - 1) || gok(q - n[m - 1], m - 1));
    ok[make_pair(q, m)] = k + 1;
    return k;
}

bool cmp(int a, int b){
    return a > b;
}

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int q, m, k;
    cin >> q >> m >> k;
    int sum = 0;
    for (int i = 0; i < m; i++){
        cin >> n[i];
        sum += n[i];
    }
    for (int i = 0; i < k; i++){
        cin >> r[i];
    }
    if (sum == q){
        cout << sum;
        return 0;
    }
    if (sum < q){
        int ans = sum;
        sort(r, r + k, cmp);
        for (int i = 0; i < k; i++){
            if (sum < q){
                ans += min(r[i], q - sum) - 1;
                sum += min(r[i], q - sum);
            }
        }
        cout << ans;
        return 0;
    }
    if (gok(q, m)){
        cout << q;
        return 0;
    }
    cout << q - 1;
    return 0;
}
