#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
vector <int> tmp;
const int MAXN = 400001;
int g[MAXN], gc = 0;
char tp[MAXN];
int a[MAXN], b[MAXN], d[MAXN];

ll sm[MAXN];
bool flag[MAXN];
ll mh[MAXN];
ll val[MAXN];

void setval(int v, ll vl, int l, int r)
{
	flag[v] = true;
	val[v] = vl;
	sm[v] = (g[r + 1] - g[l]) * vl;
	if (vl > 0) mh[v] = max(0ll, sm[v]);
	else mh[v] = 0;
}

void upd(int v)
{
	sm[v] = sm[v * 2 + 1] + sm[v * 2 + 2];
	mh[v] = max(mh[v * 2 + 1], sm[v * 2 + 1] + mh[v * 2 + 2]);
}

void push(int v, int l, int r)
{
	if (!flag[v]) return;
	flag[v] = false;
	setval(v * 2 + 1, val[v], l, (l + r) / 2);
	setval(v * 2 + 2, val[v], (l + r) / 2, r);
}

int lv, rv;
ll dd;

void modify_rmq(int v, int l, int r)
{
	if (l > rv) return;
	if (lv > r) return;
	if ((lv <= l) && (r <= rv))
	{
		setval(v, dd, l, r);
	}
	else
	{
		push(v, l, r);
		modify_rmq(v * 2 + 1, l, (l + r) / 2);
		modify_rmq(v * 2 + 2, (l + r) / 2 + 1, r);
		upd(v);
	}
}

char ss[4];
int main()
{
	//freopen("input.txt",  "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	tmp.push_back(n);
	tmp.push_back(0);
	n = 0;
	while (true)
	{
		scanf("%s", ss);
		tp[n] = ss[0];
		if (tp[n] == 'E') break;
		scanf("%d", &a[n]);
		if (tp[n] == 'I')
		{
			scanf("%d%d", &b[n], &d[n]);
			tmp.push_back(a[n] - 1);
			tmp.push_back(b[n]);
		}
		n++;
	}
	sort(tmp.begin(), tmp.end());
	for (int i = 0; i < tmp.size(); i++)
	{
		if ((i == 0) || (tmp[i - 1] != tmp[i])) g[gc++] = tmp[i];
	}
	for (int i = 0; i < MAXN; i++) flag[i] = true, sm[i] = mh[i] = val[i] =0;
	for (int i = 0; i < n; i++)
	{
		if (tp[i] == 'Q')
		{
			ll h = a[i];
			int cv = 0, cl = 0, cr = gc - 2;
			if (mh[0] <= h) 
			{
				cout << g[gc - 1] << endl;
				continue;
			}
			while (cl != cr)
			{
				push(cv, cl, cr);
				if (mh[cv * 2 + 1] > h) cv = cv * 2 + 1, cr = (cl + cr) / 2;
				else
				{
					h -= sm[cv * 2 + 1];
					cv = cv * 2 + 2;
					cl = (cl + cr) / 2 + 1;
				}
			}
			cout << g[cl] + h / val[cv] << endl;
		}
		else
		{
			lv = lower_bound(g, g + gc, a[i] - 1) - g;
			rv = lower_bound(g, g + gc, b[i]) - g - 1;
	  		dd = d[i];
			modify_rmq(0, 0, gc - 2);
		}
	}
	return 0;
}		