#include <bits/stdc++.h>
#include "grader.h"

#ifndef LOCAL
#define stderr lorem_ipsum
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

const int N = 300179;
const int Q = 2015;

int n, m, p, q, *g;
vector < int > e[N];
int nxt[N];
vector < int > prv[N];
int ans[Q];
unordered_map < int , int > k2i;

void solveDFS(int v, int s)
{
    if (k2i.find(s) != k2i.end())
        if (v >= n || sz(e[v]) == 1)
            ++ans[k2i[s]];
    for (int nv : prv[v])
        solveDFS(nv, s + 1);
}

vector < pair < int , bool > > ev;

void dfs(int v, int s, int zz)
{
    if (v >= n || sz(e[v]) == 1)
        ev.push_back({s, false});
    for (int nv : prv[v])
        if (nv != zz)
            dfs(nv, s + 1, zz);
}

void solve(int f)
{
    if (nxt[f] == -1)
        return;
    static bool vis[N];
    memset(vis, 0, sizeof(vis));
    int curr = f;
    int llen = 0;
    while (!vis[curr])
    {
        ++llen;
        vis[curr] = true;
        curr = nxt[curr];
    }
    if (curr != f)
    {
        solveDFS(f, 0);
        return;
    }

    ev.clear();
    dfs(f, 0, f);
    for (int i = 0; i < q; ++i)
        ev.push_back({g[i], true});
    sort(ev.begin(), ev.end());

    static int addx[N];
    memset(addx, 0, sizeof(addx));
    for (auto pp : ev)
        if (pp.second)
        {
            int gg = k2i[pp.first];
            ans[gg] += addx[pp.first % llen];
        } else
            ++addx[pp.first % llen];
}

void count_routes(int _n, int _m, int _p, int r[][2], int _q, int _g[])
{
    n = _n; m = _m; p = _p; q = _q; g = _g;

    for (int i = 0; i < q; ++i)
        k2i[g[i]] = i;

    for (int i = m-1; i >= 0; --i)
    {
        e[r[i][0]].push_back(r[i][1]);
        e[r[i][1]].push_back(r[i][0]);
    }

    for (int i = 0; i < n; ++i)
    {
        if (sz(e[i]) == 1)
        {
            nxt[i] = e[i][0] + (i == e[e[i][0]].back() ? 0 : n);
            nxt[n+i] = -1;
        } else {
            nxt[i] = e[i][sz(e[i])-2] + (i == e[e[i][sz(e[i])-2]].back() ? 0 : n);
            nxt[n+i] = e[i].back() + (i == e[e[i].back()].back() ? 0 : n);
        }
        //std::cerr << "nxt[" << i << "]     = " << nxt[i+n] << "\n";
        //std::cerr << "nxt_wbd[" << i << "] = " << nxt[i] << "\n";
    }

    for (int i = 0; i < n*2; ++i)
    {
        if (nxt[i] != -1)
            prv[nxt[i]].push_back(i);
        //std::cerr << i << ": " << nxt[i] << "\n";
    }

    solve(p);
    solve(n+p);

    for (int i = 0; i < q; ++i)
        answer(ans[i]);
}
