#include <iostream>
#include <cstdio>

using namespace std;

long long fl[1000001], cl[1000001], cn[1000001];
long long m;

long long get(int a, int b, int c, int len){
    if (a == b - 1) return cn[len];
    if (a == b - 2 && c == b - 1) return cl[len];
    if (a == b - 2) return fl[len];
    return 0;
}

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int n;
    cin >> n >> m;
    string s;
    cin >> s;
    fl[0] = 1;
    cl[0] = 1;
    cn[0] = 1;
    for (int i = 1; i <= n; i++){
        cn[i] = (cn[i - 1] + fl[i - 1]) % m;
        fl[i] = (fl[i - 1] + (!(i % 2)) * fl[i - 1]) % m;
        cl[i] = (cl[i - 1] + (i % 2) * cl[i - 1]) % m;
    }
    int bal = 0;
    int mx = 0;
    int mn = 0;
    long long ans = 1;
    for (int i = 0; i < n; i++){
        if (s[i] == 'P'){
            ans = (ans + get(min(mn, bal - 1), mx, bal - 1, n - i - 1)) % m;
            bal++;
        }
        else{
            bal--;
        }
        if (bal > mx) mx = bal;
        if (bal < mn) mn = bal;
    }
    cout << ans;
    return 0;
}
