#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

struct ev{
    int num, sum, prs;

    ev(){
        prs = 0;
        sum = 0;
    }

    ev(int _num, int _sum, int _prs){
        num = _num;
        sum = _sum;
        prs = _prs;
    }
};

bool operator < (ev a, ev b){
    return (a.sum > b.sum) || (a.sum == b.sum && a.prs > a.prs) || (a.sum == b.sum && a.prs == b.prs && a.num < b.num);
}

ev a[2001];
int ct[2001];
int b[2001][2001];

int main()
{
    int n, t, p;
    cin >> n >> t >> p;
    p--;
    for (int i = 0; i < n; i++){
        a[i].num = i;
        for (int j = 0; j < t; j++){
            scanf("%d", &b[i][j]);
            if (b[i][j]){
                a[i].prs++;
            }
            else{
                ct[j]++;
            }
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < t; j++){
            if (b[i][j]) a[i].sum += ct[j];
        }
    }
    sort(a, a + n);
    for (int i = 0; i < n; i++){
        if (a[i].num == p){
            cout << a[i].sum << " " << i + 1;
            return 0;
        }
    }
    return 0;
}
