#include <iostream>
#include <cstdio>
#include <cstdlib>

using namespace std;

int x[20001];
int y[20001];
int lenx[20001][2001];
int leny[20001][2001];
const int INF = 1e9;

int main(){
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    int n;
    scanf("%d", &n);
    x[0] = 1000;
    y[0] = 1000;
    for (int i = 1; i <= n; i++){
        scanf("%d%d", &x[i], &y[i]);
        x[i] += 1000;
        y[i] += 1000;
    }
    for (int i = 0; i < 2001; i++){
        lenx[0][i] = INF;
        leny[0][i] = INF;
    }
    lenx[0][1000] = 0;
    leny[0][1000] = 0;
    for (int i = 1; i <= n; i++){
        for (int j = 0; j < 2001; j++){
            lenx[i][j] = INF;
            leny[i][j] = INF;
        }
        for (int j = 0; j < 2001; j++){
            lenx[i][j] = min(lenx[i][j], lenx[i - 1][j] + abs(y[i - 1] - y[i]));
            leny[i][j] = min(leny[i][j], leny[i - 1][j] + abs(x[i - 1] - x[i]));
            lenx[i][x[i - 1]] = min(lenx[i][x[i - 1]], leny[i - 1][j] + abs(j - y[i]));
            leny[i][y[i - 1]] = min(leny[i][y[i - 1]], lenx[i - 1][j] + abs(j - x[i]));
        }
    }
    int ans = INF;
    for (int i = 0; i < 2001; i++){
        if (ans > lenx[n][i]) ans = lenx[n][i];
        if (ans > leny[n][i]) ans = leny[n][i];
    }
    printf("%d", ans);
    return 0;
}
